C-----------------------------------------------------------------------
C
C             PROGRAM     M O S E S
C
C     MOde-coupling Single bunch instability in an Electron Storage ring
C
C     YONG HO CHIN,   CERN/SL-AP, KEK ACCELERATOR DIVISION
C                     OCTOBER 1994
C
C     11.4.88 INCLUSION OF BETATRON TUNE SPREAD   VERSION M.2.0
C     20.4.93 PLOT OF EIGENMODES VS. CURRENT      VERSION M.2.1
C     22.4.93 IMPLEMENTATION OF ZOTTER'S FORMULA  VERSION M.2.2
C     26.4.93 ADDITION OF BINOMIAL DISTRIBUTION   VERSION M.3.0
C     30.4.93 CHANGE IN LAYOUT OF EIGENVALUE PLOT VERSION M.3.1
C     16.6.93 CORRECTION IN INTEGRATION METHOD    VERSION M.3.2
C     21.6.93 CORRECTION IN DZERO SUBROUTINE      VERSION M.3.3
C     29.8.05 WINDOWS APPLICATION VERSION         VERSION M.4.0
C
C-----------------------------------------------------------------------
C     *** NOTE: HOW TO CHANGE THE SIZES OF ARRAYS
C
C     VM/CMS COMMAND PROCEEDURE
C
C     XEDIT MOSES FORTRAN
C
C     C/NM=500/NM=VALUE YOU LIKE/ * *
C     C/NS=10/NS=##/ * *
C     C/NCM=1005/NCM=###/ * *
C     SAVE
C
C     *** COMMENTS ***
C
C     NM=MAXIMUM MATRIX SIZE
C     NS=MAXIMUM NUMBER OF STEPS FOR BETATRON TUNE SPREAD
C     NCM=MAXIMUM NUMBER OF STEPS FOR BUNCH CURRENT
C-----------------------------------------------------------------------
      PARAMETER (NM=500)
      PARAMETER (NS=10)
      PARAMETER (NCM=1005)
C-----------------------------------------------------------------------
      IMPLICIT REAL*8(A-H,O-Z)
      LOGICAL*1 IPRINT,LINTGL,LMTRIX,LMAP,LDIV,LPLE,LZOT,LBIN,LREST
      CHARACTER*1 LZEIS
      CHARACTER*8 ZTXT(9)
      CHARACTER*8 NDATE,NTIME
C FOR VAX USERS
C     REAL*8 NDATE,NTIME
      CHARACTER*34 MESG,MESD,MESM,MESN
      CHARACTER*42 TXTSYN,TXTBUN,TXTSPD,FRGSYN,FRGBUN,FRGSPD,FRGNON
	CHARACTER*256 NMEA,NMEO,NMET
      INTEGER*4 Q,T,JSTK(NM)
      REAL*4 AR(NM,NM),AI(NM,NM),WR(NM),WI(NM),WORK(2*NM)
C     REAL*4 ZR(NM,NM),ZI(NM,NM)
      REAL*4 ABSDET
      REAL*4 EIGR(NM,NCM),EIGI(NM,NCM),ALOW,BLOW
      REAL*4 QXYMM(4),EFI(NCM),DUMMY
      REAL*4 QXMIN,QXMAX,QYMIN,QYMAX,QYDEF
      REAL*8 ESTR(NM,NCM,NS),ESTI(NM,NCM,NS)
      REAL*8 NUS,CRP(5),SGMP(5),NUSV,NUSTOC
      REAL*8 Y0(2,3),ALPHB(3),CEPS(2),YY(2),NUSP(5)
      COMPLEX*16 ANU1,ANU2,PSG1,PSG2,CWERF,FGAUSS,ANU,FINT,AINF,FBIN
      COMPLEX*16 S01,S02,CB(0:NM),PHAS1,PHAS2,AINE
      COMPLEX*16 S(2*NM),AM,SM(NM,NM)
      COMPLEX*16 DET,XI,XF,AIN1,AIN2
C-----------------------------------------------------------------------
      EXTERNAL DET
      EXTERNAL FUN
      EXTERNAL ABSDET
      EXTERNAL FINT
      EXTERNAL FBIN
      EXTERNAL FRT
C-----------------------------------------------------------------------
      DATA LZEIS/'*'/
      DATA CLIGHT/2.99792D0/,PI/3.1415927D0/
      DATA EPS/1.D-7/
      DATA FRGSYN/'<< SYNCHROTRON TUNE VARIES WITH CURRENT >>'/
      DATA FRGBUN/'<< BUNCH LENGTH VARIES WITH CURRENT >>    '/
      DATA FRGSPD/'      << BETATRON TUNE HAS SPREAD >>      '/
      DATA FRGNON/'                                          '/
      DATA MESN/'                                  '/
      DATA MESD/'<<< DISPERSION INTEGRAL METHOD >>>'/
      DATA MESM/'<<< DISPERSION MATRIX METHOD >>>  '/
      DATA CEPS/1.D-10,0.D0/
      DATA ALPHB/0.D0,0.D0,0.D0/
      DATA NX0,MX0,IOPT,ITMAX/2,3,2,200/
      DATA Y23U/2.D0/
      DATA DEPS/5.D-3/
C-----------------------------------------------------------------------
      NAMELIST/MPARM/NUS,ENGY,SGMZ,BETAC,REVFRQ,ALPHA,CHROM,SPRD,SGMTOC,
     &  CTOSGM,NUSTOC,CTONUS,ALFA
      NAMELIST/CPARM/CRNT,STPC,NCR,NMODF,NMODE,KRAD,IPRINT,LPLE,LZOT,
     & LBIN,MU
      NAMELIST/IPARM/FREQ,RS,QV
      NAMELIST/HPARM/MMIN,MMAX,TAUMIN,TAUMAX,NSPL
      NAMELIST/SPARM/LMTRIX,LINTGL,LMAP,NDISP,NSTPS,SPRD0,EX,EY,FEPS,
     & ZEPS,DXMAX,ESPC,CXMAX
C-----------------------------------------------------------------------
      COMMON /COM/ SGM,RAD,SGMTOC(NCM),CTOSGM(NCM)
      COMMON /CON/ NUS,NUSTOC(NCM),CTONUS(NCM)
      COMMON /TUNE/ NUSV,SPRD,LMTRIX
      COMMON /MTRX/ AM(NM,NM)
      COMMON /MPA/ NMODE,NMODF,KRAD
      COMMON /SOL/ SOLR(NM),SOLI(NM),NOTH,LDIV
      COMMON /INT/ ANU,SGMV,CHROM,ALPHA,MU,IORD,MM,NN
      COMMON /FBI/ EMN
C-----------------------------------------------------------------------
C SET DEFAULT VALUES
C-----------------------------------------------------------------------
      IPRINT=.TRUE.
      LMTRIX=.FALSE.
      LINTGL=.TRUE.
      LMAP=.FALSE.
      LPLE=.FALSE.
      LZOT=.FALSE.
      LBIN=.FALSE.
      LREST=.FALSE.
      MU=0
      CHROM=0.
      NCR=60
      NMODE=-2
      NMODF=1
      KRAD=0
      TAUMAX=.1
      TAUMIN=-.1
      SPRD=0.
      NDISP=9
      NSPL=1
      NSTPS=1
      SPRD0=0.
      EX=0.1
      EY=0.01
      FEPS=0.
      ZEPS=0.
      DXMAX=0.5
      ESPC=0.001
      CXMAX=0.5
      ALPHA=0.0
      ALFA=0.0
      DO 91 I=1,NCM
      SGMTOC(I)=0.D0
      CTOSGM(I)=0.D0
      NUSTOC(I)=0.D0
   91 CTONUS(I)=0.D0
C-----------------------------------------------------------------------
C START CLOCK
C-----------------------------------------------------------------------
      CALL CPUTIM(TT,1)
C-----------------------------------------------------------------------
C OPEN STATEMENTS TO INITIALIZE INPUT AND OUTPUT FILES
C THE FOLLOWING IS AN EXAMPLE TO RUN MOSES FOR SAMPLE1 FILE ON WINDOWS
C-----------------------------------------------------------------------
      OPEN(5, FILE=' ',STATUS='UNKNOWN')
	INQUIRE(UNIT=5, NAME=NMEA)
	CALL ASFILE(NMEA,NMEO,NMET)
      OPEN(6, FILE=NMEO,STATUS='UNKNOWN')
      OPEN(9, FILE=NMET,STATUS='UNKNOWN')
C-----------------------------------------------------------------------
C READ TITLE OF JOB
      READ(5,1060) (ZTXT(K),K=1,9)
 1060 FORMAT(9A8)
C READ MACHINE PARAMETERS
      READ(5,MPARM)
C READ BEAM PARAMETERS
      READ(5,CPARM)
C READ IMPEDANCE PARAMETERS
      READ(5,IPARM)
C SET DEFAULT VALUE FOR PLOT
      MMIN=NMODF
      MMAX=NMODE
C READ BOOKING PARAMETERS
      READ(5,HPARM)
C READ TUNE SPREAD PARAMETERS
      IF (SPRD.NE.0.D0) READ(5,SPARM)
C-----------------------------------------------------------------------
C PRINT OUT ALL INPUT DATA
C-----------------------------------------------------------------------
      IF(FEPS.NE.0.) CEPS(1)=FEPS
      IF(ZEPS.NE.0.) CEPS(2)=ZEPS
      IF(FEPS.EQ.0.) FEPS=CEPS(1)
      IF(ZEPS.EQ.0.) ZEPS=CEPS(2)
      IF(SPRD.EQ.0.) NDISP=0
      IF(LINTGL) NDISP=0
      TXTSYN=FRGNON
      IF(NUS.LE.0.) TXTSYN=FRGSYN
      TXTBUN=FRGNON
      IF(SGMZ.LE.0.) TXTBUN=FRGBUN
      TXTSPD=FRGNON
      IF(SPRD.NE.0.) TXTSPD=FRGSPD
      SPRDS=SPRD
      IF(.NOT.LMTRIX) NDISP=0
      IF(ALPHA.EQ.0.) ALPHA=ALFA
      ALPH0=ALPHA
C
      CALL DATIMH(NDATE,NTIME)
      WRITE(6,1002) (ZTXT(I),I=1,9),NDATE,NTIME
      WRITE(6,1004)
      WRITE(6,1006) NUS,TXTSYN,ENGY,SGMZ,TXTBUN,BETAC,REVFRQ,
     &              ALPHA,CHROM,SPRD,TXTSPD
      WRITE(6,1008)
      WRITE(6,1012) FREQ,RS,QV
      WRITE(6,1014)
      WRITE(6,1016) CRNT,STPC,NCR,NMODF,NMODE,KRAD,IPRINT,LBIN
      IF(LBIN) WRITE(6,1017) MU
      WRITE(6,1018)
      WRITE(6,1020) MMAX,MMIN,TAUMAX,TAUMIN,NSPL
      IF (SPRD.NE.0.D0) WRITE(6,1019)
      IF (SPRD.NE.0.D0) WRITE(6,1021) LMTRIX,LINTGL,LMAP,NDISP,NSTPS,
     & SPRD0,EX,EY,FEPS,ZEPS,DXMAX,ESPC,CXMAX
C-- OUTPUT FORMAT ------------------------------------------------------
 1002 FORMAT(/1X,76(1H*)/1X,1H*,74X,1H*
     1 /1X,1H*,'                               MOSES      ',32X,1H*
     2 /1X,2H* ,72(1H ),2H *
     $ /1X,1H*,'    MOde-coupling Single bunch instability ',
     $         'in an Electron Storage ring',4X,1H*
     2 /1X,2H* ,72(1H ),2H *
     3 /1X,2H* ,9(A8),2H *
     2 /1X,2H* ,72(1H ),2H *
     3 /1X,2H* ,'    DATE:',A8,'    TIME:',A8,
     3 2X,'   VERSION 4.0,   AUGUST    2005',3X,1(1H ),2H *
     4 /1X,2H* ,72(1H ),2H *
     5 /1X,76(1H*)/)
 1001 FORMAT('1'/1X,37(1H*),3(1H>),' BUNCH LENGTH VARIES WITH BUNCH',
     1' CURRENT AS FOLLOWS ',3(1H<),37(1H*))
 1003 FORMAT(/1X,'Current (mA)       /',10(F10.3,1X))
 1007 FORMAT(1X,'Bunch Length (cm)  /',10(F10.3,1X))
 1061 FORMAT('1'/1X,35(1H*),3(1H>),' SYNCHROTRON TUNE VARIES WITH',
     1 ' BUNCH CURRENT AS FOLLOWS ',3(1H<),35(1H*))
 1067 FORMAT(1X,'Synchrotron tune   /',10(F10.3,1X))
 1004 FORMAT(/1X,'$MAPRM:')
 1005 FORMAT(/1X,131(1H*))
 1006 FORMAT(1X,'SYNCHROTRON TUNE               :  NUS      =',G13.5,
     1 10X,A42/
     1 1X,'BEAM ENERGY                    :  ENGY     =',G13.5,'(GeV)'/
     2 1X,'RMS BUNCH LENGTH               :  SGMZ     =',G13.5,'(cm)',
     1 8X,A42/
     3 1X,'BETA-FUNCTION AT IMPEDANCE     :  BETAC    =',G13.5,'(m)'/
     4 1X,'REVOLUTION FREQUENCY           :  REVFRQ   =',G13.5,'(MHz)'/
     5 1X,'MOMENTUM COMPACTION FACTOR     :  ALPHA    =',G13.5/
     6 1X,'CHROMATICITY                   :  CHROM    =',G13.5/
     7 1X,'BETATRON TUNE SPREAD AT SIGMA  :  SPRD     =',G13.5,10X,A42)
 1008 FORMAT(/1X,'$IPARM:')
 1012 FORMAT(1X,'RESONANT FREQUENCY             :  FREQ     =',G13.5,
     1 '(MHz)'/
     1 1X,'IMPEDANCE                      :  RS       =',G13.5,
     1 '(MOhm/m)'/
     2 1X,'Q - VALUE                      :  QV       =',G13.5)
 1014 FORMAT(/1X,'$CPARM:')
 1016 FORMAT(1X,'STARTING CURRNT                :  CRNT     =',G13.5,
     1 '(mA)'/
     2 1X,'STEP IN CURRENT                :  STPC     =',G13.5,'(mA)'/
     3 1X,'NUMBER OF STEPS IN CURRENT     :  NCR      =',I6/
     4 1X,'LOWEST AZIMUTHAL MODE          :  NMODF    =',I6/
     5 1X,'HIGHEST AZIMUTHAL MODE         :  NMODE    =',I6/
     6 1X,'NUMBER OF LONG. RADIAL MODES   :  KRAD     =',I6/
     8 1X,'PRINT OF EIGENVALUES           :  IPRINT   =',5X,L1/
     8 1X,'USE OF A BINOMIAL DISTRIBUTION :  LBIN     =',5X,L1)
 1017 FORMAT(1X,'BINOMIAL MODE NUMBER           :  MU       =',I6)
 1018 FORMAT(/1X,'$HPARM:')
 1020 FORMAT(1X,'MAXIMUM AZIMUTHAL MODE IN PLOT :  MMAX     =',I6/
     1 1X,'MINIMUM AZIMUTHAL MODE IN PLOT :  MMIN     =',I6/
     2 1X,'MAXIMUM COORDINATE IN TAU PLOT :  TAUMAX   =',G13.5/
     3 1X,'MINIMUM COORDINATE IN TAU PLOT :  TAUMIN   =',G13.5/
     4 1X,'NUMBER OF SPLITTED PLOTS       :  NSPL     =',I6)
 1019 FORMAT(/1X,'$SPARM:')
 1021 FORMAT(1X,'DISPERSION MATRIX METHOD       :  LMTRIX   =',5X,L1/
     1 1X,'DISPERSION INTEGRAL METHOD     :  LINTGL   =',5X,L1/
     1 1X,'PLOT OF ABS(DETERMINANT)       :  LMAP     =',5X,L1/
     2 1X,'NUMBER OF TRANS. RADIAL MODES  :  NDISP    =',I6/
     3 1X,'NUMBER OF STEPS IN SPREAD      :  NSTPS    =',I6/
     4 1X,'STARTING TUNE SPREAD           :  SPRD0    =',G13.5/
     5 1X,'STEP IN REAL TUNE(=X) SEARCH   :  EX       =',G13.5/
     5 1X,'STEP IN IMAG TUNE(=Y) SEARCH   :  EY       =',G13.5/
     8 1X,'CRITERION FOR CONVERGENCE OF F :  FEPS     =',G13.5/
     9 1X,'CRITERION FOR CONVERGENCE OF Z :  ZEPS     =',G13.5/
     6 1X,'MAXIMUM DIFFERENCE OF X        :  DXMAX    =',G13.5/
     7 1X,'MINIMUM DISTANCE BTWEEN TUNES  :  ESPC     =',G13.5/
     9 1X,'MAXIMUM CHANGE IN X            :  CXMAX    =',G13.5/)
C-----------------------------------------------------------------------
C SET UP THE REST OF PARAMETERS WHICH ARE NESSESARY FOR CALCULATION
C-----------------------------------------------------------------------
      D2=DSQRT(2.D0)
      IF(ALPHA.EQ.0.) CHROM=0.0
      IF(ALPHA.EQ.0.) ALPHA=1.0
      NT=NM
C     NCR=NCR+1
      SCLFCT=BETAC*1.D-12/(4.D0*ENGY)
      RAD=CLIGHT*1.D4/(2.D0*PI*REVFRQ)
      SGM=SGMZ/RAD
      AK=SCLFCT*RS*1.0D6*FREQ/(PI*REVFRQ*DSQRT(4.D0*QV**2-1.D0))
      ANU1=FREQ*((0.D0,-1.D0)+DSQRT(4.D0*QV**2-1.D0))/(REVFRQ*2.D0*QV)
      ANU2=FREQ*((0.D0,-1.D0)-DSQRT(4.D0*QV**2-1.D0))/(REVFRQ*2.D0*QV)
      IF(-DIMAG(2*PI*ANU1).LT.10) LREST=.TRUE.
      IF(LREST) PHAS1=CDEXP(-(0.D0,1.D0)*ANU1*2.*PI)
      IF(LREST) PHAS2=CDEXP(-(0.D0,1.D0)*ANU2*2.*PI)
      AK0=AK
      IF(SGMZ) 95,96,97
   95 DO 98 I=1,NCR
      CRNTM=CRNT+DFLOAT(I-1)*STPC
      SGMTOC(I)=FSGM(CRNTM)*RAD
      CTOSGM(I)=CRNTM
   98 CONTINUE
   96 WRITE(6,1001)
C-----------------------------------------------------------------------
C PRINT BUNCH LENGTH AS A FUNCTION OF CURRENT
C-----------------------------------------------------------------------
      DO 92 I=1,12
      I1=(I-1)*10
      IF(SGMTOC(I1+1).EQ.0.D0) GO TO 93
      WRITE(6,1003) (CTOSGM(I1+K),K=1,10)
      WRITE(6,1007) (SGMTOC(I1+K),K=1,10)
   92 CONTINUE
   93 WRITE(6,1005)
   97 CONTINUE
C-----------------------------------------------------------------------
      IF(NUS) 85,86,87
   85 DO 88 I=1,NCR
      CRNTM=CRNT+DFLOAT(I-1)*STPC
      NUSTOC(I)=FNUS(CRNTM)
      CTONUS(I)=CRNTM
   88 CONTINUE
   86 WRITE(6,1061)
C-----------------------------------------------------------------------
C PRINT SYNCHROTRON TUNE AS A FUNCTION OF CURRENT
C-----------------------------------------------------------------------
      DO 57 I=1,12
      I1=(I-1)*10
      IF(NUSTOC(I1+1).EQ.0.D0) GO TO 58
      WRITE(6,1003) (CTONUS(I1+K),K=1,10)
      WRITE(6,1067) (NUSTOC(I1+K),K=1,10)
   57 CONTINUE
   58 WRITE(6,1005)
   87 CONTINUE
C-----------------------------------------------------------------------
C SET NQ: TOTAL NUMBER OF MODES
C-----------------------------------------------------------------------
      NE=(KRAD+1)*(NMODE-NMODF+1)
      MAXM=MAX(IABS(NMODF),IABS(NMODE))
      NP=2*MAXM+4*KRAD
      NQ=NE*(NDISP+1)
      AK=AK0
      CRNTM=CRNT
      IF(NQ.LE.NM) GO TO 77
      WRITE(6,1031) NQ,NM
 1031 FORMAT(1X,'********>>> STOP <<<******************************'//
     1      1X,'TOTAL NUMBER OF MODES:',I5,' EXCEEDS MAXIMUM NM:',I5//
     2       1X,'**************************************************')
      STOP
   77 IF(NCR.LE.NCM) GO TO 78
      WRITE(6,1032) NCR,NCM
 1032 FORMAT(1X,'********>>> STOP <<<******************************'//
     1      1X,'NCR:',I5,' EXCEEDS MAXIMUM NCM:',I5//
     2       1X,'**************************************************')
      STOP
   78 CONTINUE
      IF(NSTPS.LE.NS) GO TO 79
      WRITE(6,1033) NSTPS
 1033 FORMAT(1X,'********>>> STOP <<<******************************'//
     1      1X,'NSTPS:',I5,' EXCEEDS MAXIMUM NS:',I5//
     2       1X,'**************************************************')
      STOP
   79 CONTINUE
      IF(SPRD.EQ.0.0.OR.(.NOT.LBIN)) GO TO 76
      WRITE(6,1034)
 1034 FORMAT(1X,'*****>>> WARNING <<<******************************'//
     1      1X,'NO TUNE SPREAD IS ALLOWED WHEN LBIN=.T.'//
     2       1X,'**************************************************')
      STOP
   76 CONTINUE
C-----------------------------------------------------------------------
C     START OF CALCULATION
C     DEFINITION OF SYMBOLS
C     SGM=SIGAMZ/RADIUS
C     CRNTM=CURRENT AT EACH STEP
C-----------------------------------------------------------------------
      FACM=DSQRT(DFLOAT(2*(MU+2)))
      IF(.NOT.LBIN) FACM=1.D0
      SGMOLD=FSGM(CRNTM)
      SGMRAT=1.0
      DO 10 I=1,NCR
      SGMV=FSGM(CRNTM)
      NUSV=FNUS(CRNTM)
      AK=AK0*CRNTM/NUSV
      IF(SGMOLD.NE.0.0) SGMRAT=DABS(SGMV-SGMOLD)/SGMOLD
      IF(I.GT.1.AND.SGMRAT.LE.1.D-3) GO TO 17
      SGMOLD=SGMV
      PSG1=(ANU1-CHROM/ALPHA)*SGMV*FACM
      PSG2=(ANU2-CHROM/ALPHA)*SGMV*FACM
      IF(.NOT.LBIN) THEN
      IF(LZOT) THEN
      IF(LREST) THEN
      S01=-PI*CDEXP(-PSG1**2)*CDCOS(PI*ANU1)/CDSIN(PI*ANU1)
     1 +(0.D0,1.D0)*PI*(CWERF(PSG1)-CDEXP(-PSG1**2))
      S02=-PI*CDEXP(-PSG2**2)*CDCOS(PI*ANU2)/CDSIN(PI*ANU2)
     1 +(0.D0,1.D0)*PI*(CWERF(PSG2)-CDEXP(-PSG2**2))
      ELSE
      S01=-(0.D0,1.D0)*PI*CWERF(-PSG1)
      S02=-(0.D0,1.D0)*PI*CWERF(-PSG2)
      END IF
      S(1)=S01-S02
      DO 11 II=1,NP/2+4
      I1=2*II-1
      I2=I1+1
C-----------------------------------------------------------------------
C SUM UP THE BUNCH SPECTRUM*IMPEDANCE
C-----------------------------------------------------------------------
      S01=S01*PSG1+DEXP(GAMMLN(REAL(II)-0.5D0))
      S02=S02*PSG2+DEXP(GAMMLN(REAL(II)-0.5D0))
      S(I1+1)=(S01-S02)/D2**I1
      S01=S01*PSG1
      S02=S02*PSG2
      S(I2+1)=(S01-S02)/D2**I2
   11 CONTINUE
      ELSE
      IORD=NP
      ACAN=6.78/SGMV
  103 IF(FRT(ACAN,1).LE.0.) GO TO 102
      ACAN=ACAN+2.26/SGMV
      GO TO 103
  102 AST=1.0/SGMV
      CALL DZERO(AST,ACAN,X0,R0,DEPS,ITMAX,FRT)
      IF(X0.NE.0.0) AINF=DMIN1(ACAN,X0)
      IF(X0.EQ.0.0) AINF=ACAN
      AINE=AINF-CHROM/ALPHA
      AINF=AINF+CHROM/ALPHA
      DO 12 II=1,NP+1
      IORD=II-1
      ANU=ANU1
      S01=FGAUSS(FINT,-AINE,AINF,EPS)
      IF(.NOT.LREST) GO TO 25
      S01=S01-PI*(0.D0,1.D0)*(PSG1/D2)**IORD*CDEXP(-PSG1**2)
     1*2.*PHAS1/(1.D0-PHAS1)
   25 ANU=ANU2
      S02=FGAUSS(FINT,-AINE,AINF,EPS)
      IF(.NOT.LREST) GO TO 26
      S02=S02-PI*(0.D0,1.D0)*(-PSG2/D2)**IORD*CDEXP(-PSG2**2)
     1*2.*PHAS2/(1.D0-PHAS2)
   26 S(II)=S01-S02
   12 CONTINUE
      END IF
      ELSE
      AINF=30./(SGMV*FACM)+CHROM/ALPHA
      AINE=30./(SGMV*FACM)-CHROM/ALPHA
      AIN1=10./(SGMV*FACM)+CHROM/ALPHA
      AIN2=10./(SGMV*FACM)-CHROM/ALPHA
      DO 13 MM=0,MAXM+2*KRAD
      DO 13 NN=0,MM
      MST=MM+MU+1
      NST=NN+MU+1
      EMM=DSQRT(FACTRL(MM+MU+1)/FACTRL(MM))
      ENN=DSQRT(FACTRL(NN+MU+1)/FACTRL(NN))
      EMN=EMM*ENN*FACTRL(MU)
      ANU=ANU1
C     S01=FGAUSS(FBIN,-AINE,AINF,EPS)
      S01=FGAUSS(FBIN,-AINE,-AIN2,EPS)+FGAUSS(FBIN,AIN1,AINF,EPS)
     1+FGAUSS(FBIN,-AIN2,AIN1,EPS)
      IF(.NOT.LREST) GO TO 27
      CALL WBSJA(PSG1,0.D0,MST,3,CB)
      S01=S01-PI*(0.D0,1.D0)*CB(NST)*CB(MST)/PSG1**(2+2*MU)
     1*2.*PHAS1/(1.D0-PHAS1)
   27 ANU=ANU2
C     S02=FGAUSS(FBIN,-AINE,AINF,EPS)
C     S02=FGAUSS(FBIN,-AINE,ZERO,EPS)+FGAUSS(FBIN,ZERO,AINF,EPS)
      S02=FGAUSS(FBIN,-AINE,-AIN2,EPS)+FGAUSS(FBIN,AIN1,AINF,EPS)
     1+FGAUSS(FBIN,-AIN2,AIN1,EPS)
      IF(.NOT.LREST) GO TO 28
      CALL WBSJA(-PSG2,0.D0,MST,3,CB)
      S02=S02-PI*(0.D0,1.D0)*CB(NST)*CB(MST)/(-PSG2)**(2+2*MU)
     1*2.*PHAS2/(1.D0-PHAS2)
   28 SM(MM+1,NN+1)=(S01-S02)*2.**(2+2*MU)
      SM(NN+1,MM+1)=SM(MM+1,NN+1)
   13 CONTINUE
C     WRITE(6,8889) SM(1,1)
C8889 FORMAT(1X,'SM(1,1)=',2G13.5)
      END IF
   17 CONTINUE
C-----------------------------------------------------------------------
C MAKE THE INTERACTION MATRIX.  SEE PAPER SPS 85-2
C-----------------------------------------------------------------------
      DO 300 M=1,NT
      DO 300 N=1,NT
      AM(M,N)=0.
  300 CONTINUE
      DO 200 Q=0,NDISP
      DO 200 M=NMODF,NMODE
      DO 200 K=0,KRAD
      DO 210 T=0,NDISP
      DO 210 N=NMODF,NMODE
      DO 210 L=0,KRAD
      MM=K+(M-NMODF)*(KRAD+1)+1+Q*NE
      NN=L+(N-NMODF)*(KRAD+1)+1+T*NE
      IAM=IABS(M)
      IAN=IABS(N)
      IF((Q.EQ.0).AND.(T.EQ.0)) THEN
      IF(.NOT.LBIN) THEN
      MNKL=IAM+IAN+2*(K+L)
      EMK=1.D0/DSQRT(FACTRL(K)*FACTRL(IAM+K))
      ENL=1.D0/DSQRT(FACTRL(L)*FACTRL(IAN+L))
      COEF=EMK*ENL*AK
      AM(MM,NN)=COEF*S(MNKL+1)*(0.D0,1.D0)**(M-N)
      ELSE
      EMK=DSQRT(FACTRL(IAM+2*K)/FACTRL(IAM+2*K+MU))*
     1DSQRT(FACTRL(K+MU+IAM)/FACTRL(K+IAM))*
     2DSQRT(FACTRL(MU+K)/(FACTRL(MU)*FACTRL(K)))
      ENL=DSQRT(FACTRL(IAN+2*L)/FACTRL(IAN+2*L+MU))*
     1DSQRT(FACTRL(L+MU+IAN)/FACTRL(L+IAN))*
     2DSQRT(FACTRL(MU+L)/(FACTRL(MU)*FACTRL(L)))
      COEF=EMK*ENL*AK*DFLOAT(MU+1)
      M1=IAM+2*K+1
      N1=IAN+2*L+1
      AM(MM,NN)=COEF*SM(M1,N1)*(0.D0,1.D0)**(M-N)
      END IF
      IF(M.LT.0) AM(MM,NN)=AM(MM,NN)*(-1.D0)**IABS(M)
      IF(N.LT.0) AM(MM,NN)=AM(MM,NN)*(-1.D0)**IABS(N)
      IF((M.EQ.N).AND.(K.EQ.L)) AM(MM,NN)=AM(MM,NN)+DFLOAT(M)+DMX(0,0)
      ELSE
      IF((Q.EQ.T).AND.(M.EQ.N).AND.(K.EQ.L)) AM(MM,NN)=AM(MM,NN)
     &  +DFLOAT(M)
      IF((M.EQ.N).AND.(K.EQ.L)) AM(MM,NN)=AM(MM,NN)+DMX(Q,T)
      END IF
      AR(MM,NN)=sngl(dreal(AM(MM,NN)))
      AI(MM,NN)=sngl(dimag(AM(MM,NN)))
  210 CONTINUE
  200 CONTINUE
C***********************************************************************
C NOW SOLVE THE EIGEN VALUE PROBLEM
C***********************************************************************
C NT: SIZE OF MATRIX
C AR: REAL PART OF MATRIX
C AI: IMAGINARY PART OF MATRIX
C WR: REAL PART OF EIGEN VALUE
C WI: IMAGINARY PART OF EIGEN VALUE
C ZR: RAL PART OF EIGEN VECTOR
C ZI: IMAGINARY PART OF EIGEN VECTOR
C-----------------------------------------------------------------------
C     CALL EISCG1(NT,NQ,AR,AI,WR,WI,ZR,ZI,IER,WORK)
      CALL EISCG2(NT,NQ,AR,AI,WR,WI,IER)
C-----------------------------------------------------------------------
C STORE RESULTS FOR ZERO BETATRON TUNE SPREAD OR FOR NONZERO ONE BY
C THE DISPERSION MATRIX METHOD
C-----------------------------------------------------------------------
      DO 65 KL=1,NQ
      EIGR(KL,I)=WR(KL)
      EIGI(KL,I)=-WI(KL)
   65 CONTINUE
C-----------------------------------------------------------------------
C SKIP THE FOLLOWING CALCULATION IF LMTRIX=.TRUE. OR LINTGL=.FALSE.
C-----------------------------------------------------------------------
      IF(LMTRIX) GO TO 62
      IF(.NOT.LINTGL) GO TO 62
      IF(SPRDS.EQ.0.) GO TO 62
C-----------------------------------------------------------------------
C SOLUTIONS FOR NONZERO BETATRON TUNE SPREAD BY THE INTEGRAL METHOD
C-----------------------------------------------------------------------
      DO 450 IS=1,NSTPS
      IF(SPRD0.EQ.0.) SPRD=SPRDS*DFLOAT(IS)/DFLOAT(NSTPS)
      IF(SPRD0.NE.0.) SPRD=SPRD0+(SPRDS-SPRD0)*DFLOAT(IS-1)/
     & DFLOAT(NSTPS-1)
C-----------------------------------------------------------------------
C IF LMAP=.TRUE., PLOT ABS(DET) VIA MAP
C-----------------------------------------------------------------------
C     IF (LMAP) CALL MAP(ABSDET,FLOAT(MMIN),FLOAT(MMAX),0.05)
C     IF (LMAP) WRITE(6,452) CRNTM, SPRD
C 452 FORMAT(//1X,'PLOT OF ABSOLUTE VALUE OF DETERMINANT OF INTERACTION'
C    1 ,' MATRIX AS A FUNCTION OF Real(Nu-Nux)/Nus FOR'/
C    2 1X,'CURRENT =',G13.5,' (mA)',5X,'BETATRON TUNE SPREAD =',
C    3 G13.5)
C-----------------------------------------------------------------------
C SEARCH OF THE BEST INITIAL ESTIMATES OF SOLUTIONS
C-----------------------------------------------------------------------
      NOTH=0
      DO 401 KL=1,NE
C-----------------------------------------------------------------------
C FROM RESULTS FOR A SMALLER TUNE SPREAD?
C-----------------------------------------------------------------------
      IF (IS.EQ.1) THEN
      Z0=DBLE(WR(KL))-2.*SPRD/NUSV
      Z1=DBLE(WI(KL))
      ELSE
      Z0=ESTR(KL,I,IS-1)
      Z1=-ESTI(KL,I,IS-1)
      DO 462 LK=1,NE
      IF (LK.EQ.KL) GO TO 462
      DX0=DSQRT((Z0-ESTR(LK,I,IS-1))**2+(Z1+ESTI(LK,I,IS-1))**2)
      IF(DX0.GT.ESPC) GO TO 462
      Z0=DBLE(WR(KL))-2.*SPRD/NUSV
      Z1=DBLE(WI(KL))
  462 CONTINUE
      END IF
C-----------------------------------------------------------------------
C FROM RESULTS FOR A SMALLER BEAM CURRENT?
C-----------------------------------------------------------------------
      IF(I.EQ.1) GO TO 423
      DX0MIN=DXMAX
      JSTK(KL)=NM
      DO 410 J=1,NE
      DX0=DSQRT((Z0-ESTR(J,I-1,IS))**2+(Z1+ESTI(J,I-1,IS))**2)
      IF (DX0.GT.DX0MIN) GO TO 410
      IF(KL.EQ.1) GO TO 411
      DO 412 LK=1,KL-1
      IF(J.EQ.JSTK(LK)) GO TO 410
      DX1=DSQRT((ESTR(J,I-1,IS)-ESTR(JSTK(LK),I-1,IS))**2+
     &          (ESTI(J,I-1,IS)-ESTI(JSTK(LK),I-1,IS))**2)
      IF(DX1.LE.ESPC) GO TO 410
  412 CONTINUE
  411 Z0=ESTR(J,I-1,IS)
      Z1=-ESTI(J,I-1,IS)
      JSTK(KL)=J
      DX0MIN=DX0
  410 CONTINUE
  423 CONTINUE
      FMIN=1.D10
      DO 424 J=1,3,2
      Y0(1,1)=Z0
      Y0(2,1)=Z1
      Y0(1,3)=DFLOAT(J-2)*EX
      IF (DABS(Z1).LE.0.01) Y0(2,3)=EY
      IF (DABS(Z1).GT.0.01) Y0(2,3)=-Z1/Y23U
C-----------------------------------------------------------------------
C SIMPLEX METHOD
C-----------------------------------------------------------------------
      ITM=ITMAX
      LDIV=.FALSE.
      CALL DOFSM(FUN,Y0,2,NX0,MX0,ALPHB,CEPS,ITM,IOPT,YY,F,IER)
      IF(DABS(YY(1)-Z0).GT.CXMAX) GO TO 424
      IF(F.GT.FMIN) GO TO 424
      FMIN=F
      ESTR(KL,I,IS)=YY(1)
      ESTI(KL,I,IS)=-YY(2)
  424 CONTINUE
C-----------------------------------------------------------------------
C FINER SEARCH FOR NON-STATIONAL SOLUTIONS
C-----------------------------------------------------------------------
      IF (DABS(ESTI(KL,I,IS)).LE.ESPC) GO TO 407
      NOTH=NOTH+1
      SOLR(NOTH)=ESTR(KL,I,IS)
      SOLI(NOTH)=-ESTI(KL,I,IS)
      IF(NOTH.LE.1) GO TO 401
      DO 405 J=1,NOTH-1
      DX1=DSQRT((SOLR(NOTH)-SOLR(J))**2+
     &          (SOLI(NOTH)-SOLI(J))**2)
      IF (DX1.LE.ESPC) GO TO 406
  405 CONTINUE
      GO TO 401
  406 CONTINUE
      Y0(1,1)=SOLR(NOTH)
      Y0(2,1)=-SOLI(NOTH)
      Y0(1,3)=EX
      IF (DABS(Z1).LE.0.01) Y0(2,3)=EY*SOLI(NOTH)/DABS(SOLI(NOTH))
      IF (DABS(Z1).GT.0.01) Y0(2,3)=-Z1/Y23U
      ITM=ITMAX
      LDIV=.TRUE.
      CALL DOFSM(FUN,Y0,2,NX0,MX0,ALPHB,CEPS,ITM,IOPT,YY,F,IER)
      IF(DABS(YY(1)-Z0).GT.CXMAX) GO TO 401
C     IF(F.GT.FMIN) GO TO 424
C     FMIN=F
      ESTR(KL,I,IS)=YY(1)
      ESTI(KL,I,IS)=-YY(2)
      SOLR(NOTH)=YY(1)
      SOLI(NOTH)=YY(2)
      GO TO 401
  407 CONTINUE
      DX1=DSQRT(ESTR(KL,I,IS)**2+ESTI(KL,I,IS)**2)
      IF(DX1.GT.ESPC) GO TO 401
C-----------------------------------------------------------------------
C MUELLER METHOD
C-----------------------------------------------------------------------
      XI=DCMPLX(Z0,Z1)
      ITM=ITMAX
      CALL ZNTMM(DET,XI,CEPS(2),CEPS(1),ITM,XF,IER)
      IF(CDABS(XF-XI).GT.CXMAX) GO TO 401
C     IF(CDABS(DET(XF)).GT.FMIN) GO TO 401
      ESTR(KL,I,IS)=DREAL(XF)
      ESTI(KL,I,IS)=-DIMAG(XF)
  401 CONTINUE
  450 CONTINUE
C-----------------------------------------------------------------------
C NEXT CURRENT
C-----------------------------------------------------------------------
   62 CRNTM=CRNTM+STPC
   10 CONTINUE
C-----------------------------------------------------------------------
C PRINT ALL THE NUMERICAL VALUES OF EIGEN VALUES
C-----------------------------------------------------------------------
      IF(.NOT.IPRINT) GO TO 51
      NCR5=NCR/5
      IF(NCR5*5.NE.NCR) NCR5=NCR5+1
      SPRD=0.
      WRITE(6,1051)
      IF (LINTGL) WRITE(6,1058) SPRD
      DO 20 I=1,NCR5
      DO 21 K=1,5
      CRP(K)=CRNT+STPC*DFLOAT(5*(I-1)+K-1)
      NUSP(K)=FNUS(CRP(K))
   21 SGMP(K)=FSGM(CRP(K))*RAD
      WRITE(6,1052) (CRP(K),K=1,5)
      WRITE(6,1053) (SGMP(K),K=1,5)
      WRITE(6,1054) (NUSP(K),K=1,5)
      DO 22 K=1,NQ
      WRITE(6,1056) (EIGR(K,5*(I-1)+J),-EIGI(K,5*(I-1)+J),J=1,5)
   22 CONTINUE
   20 CONTINUE
      WRITE(6,1057)
C-----------------------------------------------------------------------
C PRINT ALL THE NUMERICAL VALUES OF EIGEN VALUES FOR NONZERO TUNE SPREAD
C-----------------------------------------------------------------------
      IF (.NOT.LINTGL) GO TO 51
      IF (SPRDS.EQ.0.) GO TO 51
      DO 33 IS=1,NSTPS
      IF(SPRD0.EQ.0.) SPRD=SPRDS*DFLOAT(IS)/DFLOAT(NSTPS)
      IF(SPRD0.NE.0.) SPRD=SPRD0+(SPRDS-SPRD0)*DFLOAT(IS-1)/
     & DFLOAT(NSTPS-1)
      WRITE(6,1051)
      WRITE(6,1058) SPRD
      DO 30 I=1,NCR5
      DO 31 K=1,5
      CRP(K)=CRNT+STPC*DFLOAT(5*(I-1)+K-1)
      NUSP(K)=FNUS(CRP(K))
   31 SGMP(K)=FSGM(CRP(K))*RAD
      WRITE(6,1052) (CRP(K),K=1,5)
      WRITE(6,1053) (SGMP(K),K=1,5)
      WRITE(6,1054) (NUSP(K),K=1,5)
      DO 32 K=1,NQ
      WRITE(6,1056) (SNGL(ESTR(K,5*(I-1)+J,IS)),
     &              -SNGL(ESTI(K,5*(I-1)+J,IS)),J=1,5)
   32 CONTINUE
   30 CONTINUE
      WRITE(6,1057)
   33 CONTINUE
 1051 FORMAT('1'/1X,40(1H*),3(1H>),' EIGEN VALUES (Nu-Nux)/Nus ',
     & 'VS. BUNCH CURRENT ',
     1 3(1H<),40(1H*))
 1058 FORMAT(/1X,'BETATRON TUNE SPREAD = ',G13.5)
 1052 FORMAT(/1X,'Current (mA)       / ',5(2X,F10.4,10X))
 1053 FORMAT(1X,'Bunch length (cm)  / ',5(2X,F10.4,10X))
 1054 FORMAT(1X,'Synchrotron tune   / ',5(2X,F10.4,10X)/
     1       1X,'(Nu-Nux)/Nus ...      ',2X,'(REAL : IMAGINARY)')
 1056 FORMAT(1X,'                     ',5(G9.3,':',G9.3,3X))
 1057 FORMAT(/1X,131(1H*))
   51 CONTINUE
C-----------------------------------------------------------------------
C PRINT EIGEN VALUES CURVE VIA DRPLOT
C-----------------------------------------------------------------------
      QYDEF=FLOAT(MMAX-MMIN)/FLOAT(NSPL)
      IF (STPC.GT.0.) THEN
      QXMIN=SNGL(CRNT)
      QXMAX=SNGL(CRNT+STPC*DFLOAT(NCR-1))
      ELSE
      QXMIN=SNGL(CRNT+STPC*DFLOAT(NCR-1))
      QXMAX=SNGL(CRNT)
      END IF
      QXYMM(1)=QXMIN
      QXYMM(2)=QXMAX
      DO 320 J=1,NSPL
      QYMAX=FLOAT(MMAX)-QYDEF*FLOAT(J-1)
      QYMIN=QYMAX-QYDEF
      QXYMM(3)=QYMIN
      QXYMM(4)=QYMAX
      SPRD=0.
      IF (LMTRIX) SPRD=SPRDS
C-----------------------------------------------------------------------
C SORT EIGR AND EIGI IN ORDER
C-----------------------------------------------------------------------
      DO 151 N=1,NCR
      DO 151 I=1,NQ-1
      ALOW=EIGR(I,N)
      DO 153 K=I+1,NQ
      IF(EIGR(K,N).GE.ALOW) GO TO 153
      EIGR(I,N)=EIGR(K,N)
      EIGR(K,N)=ALOW
      ALOW=EIGR(I,N)
  153 CONTINUE
  151 CONTINUE
      DO 152 N=1,NCR
      DO 152 I=1,NQ-1
      BLOW=EIGI(I,N)
      DO 154 K=I+1,NQ
      IF(EIGI(K,N).GE.BLOW) GO TO 154
      EIGI(I,N)=EIGI(K,N)
      EIGI(K,N)=BLOW
      BLOW=EIGI(I,N)
  154 CONTINUE
  152 CONTINUE
C-----------------------------------------------------------------------
C CPUTIME USED
C-----------------------------------------------------------------------
      CALL CPUTIM(TT,3)
C-----------------------------------------------------------------------
C TITLE OF FIGURE
C-----------------------------------------------------------------------
      MESG=MESN
      IF(LMTRIX) MESG=MESM
      WRITE (6,610) (ZTXT(II),II=1,9),ENGY,SPRD,NUS,SGMZ,BETAC,
     1 NDATE,NTIME,MESG,REVFRQ,ALPH0,CHROM,FREQ,RS,QV,LZOT,LBIN,MU
C-----------------------------------------------------------------------
C NOW REAL PART OF EIGENVALUES
      IF(LPLE) CALL TOPLO2(ZTXT,NDATE,NTIME,NUS,ENGY,SGMZ,BETAC,REVFRQ,
     1 ALPH0,CHROM,FREQ,RS,QV,SPRD,LBIN,MU,TT,QXYMM)
      DO 71 I=1,NQ
      DO 72 N=1,NCR
      EFI(N)=EIGR(I,N)
      IF (STPC.LT.0.) EFI(N)=EIGR(I,NCR-N+1)
      XPNT=CRNT+STPC*DFLOAT(N-1)
      IF(LPLE) WRITE(9,1011) XPNT,EFI(N)
   72 CONTINUE
      IF(LPLE) WRITE(9,1013)
      IPRI=1
      IF(I.EQ.NQ) IPRI=0
      CALL DRPLOT (6,DUMMY,EFI,NCR,LZEIS,0,QXYMM,IPRI)
   71 CONTINUE
      WRITE(6,1042) TT
 1042 FORMAT(1X/1X,98X,'TOTAL CPU TIME USED:',G10.3,'(S)')
  320 CONTINUE
 1013 FORMAT(1X,' JOIN 1')
 1011 FORMAT(1X,G13.5,2X,G13.5)
C-->
  610 FORMAT(1H1,'PROBLEM = ',9A8,10X,
     1'ENGY/GeV=',G10.3,5X,'SPRD=',G10.3/
     11X,75X,'NUS=',G10.3,4X,'SGMZ/cm=',G10.3,2X,'BETAC/m=',G10.3/
     11X,A8,2X,A8,4X,A34,12X,
     1'REVFRQ/MHz=',G10.3,6X,'ALPHA=',G10.3,4X,'CHROM=',G10.3/
     11X,70X,'FREQ/MHz=',G10.3,2X,'RS/MOhm/m=',G10.3,7X,'QV=',G10.3/
     11X,'(*) = Real part of (Nu-Nux)/Nus vs. the bunch current (mA)',
     116X,'LZOT=',L1,16X,'LBIN=',L1,16X,'MU=',I3)
C-----------------------------------------------------------------------
C PRINT EIGEN VALUES CURVE VIA DRPLOT FOR NONZERO TUNE SPREAD
C DISPERSION INTEGRAL METHOD
C-----------------------------------------------------------------------
      IF (.NOT.LINTGL) GO TO 613
      IF (SPRDS.EQ.0.) GO TO 613
      DO 321 IS=1,NSTPS
      IF(SPRD0.EQ.0.) SPRD=SPRDS*DFLOAT(IS)/DFLOAT(NSTPS)
      IF(SPRD0.NE.0.) SPRD=SPRD0+(SPRDS-SPRD0)*DFLOAT(IS-1)/
     & DFLOAT(NSTPS-1)
      QXYMM(3)=FLOAT(MMIN)
      QXYMM(4)=FLOAT(MMAX)
C-----------------------------------------------------------------------
C TITLE OF FIGURE
C-----------------------------------------------------------------------
      WRITE (6,610) (ZTXT(II),II=1,9),ENGY,SPRD,NUS,SGMZ,BETAC,
     1 NDATE,NTIME,MESD,REVFRQ,ALPH0,CHROM,FREQ,RS,QV,LZOT,LBIN,MU
C-----------------------------------------------------------------------
C REAL PART OF EIGENVALUES
C-----------------------------------------------------------------------
      IF(LPLE) CALL TOPLO2(ZTXT,NDATE,NTIME,NUS,ENGY,SGMZ,BETAC,REVFRQ,
     1 ALPH0,CHROM,FREQ,RS,QV,SPRD,LBIN,MU,TT,QXYMM)
      IF(LPLE) WRITE(9,1041)
 1041 FORMAT(1X,' SET SYMBOL 2O SIZE 0.5 ')
      DO 73 I=1,NE
      DO 74 N=1,NCR
      EFI(N)=SNGL(ESTR(I,N,IS))
      IF (STPC.LT.0.) EFI(N)=SNGL(ESTR(I,NCR-N+1,IS))
      XPNT=CRNT+STPC*DFLOAT(N-1)
      IF(LPLE) WRITE(9,1011) XPNT,EFI(N)
   74 CONTINUE
      IF(LPLE) WRITE(9,1015)
      IPRI=1
      IF(I.EQ.NE) IPRI=0
      CALL DRPLOT (6,DUMMY,EFI,NCR,LZEIS,0,QXYMM,IPRI)
   73 CONTINUE
 1015 FORMAT(1X,' PLOT ')
      WRITE(6,1042) TT
  321 CONTINUE
C-----------------------------------------------------------------------
C NOW IMAGINARY PART OF EIGENVALUE
C-----------------------------------------------------------------------
  613 QXYMM(3)=SNGL(TAUMIN)
      QXYMM(4)=SNGL(TAUMAX)
      SPRD=0.
      IF (LMTRIX) SPRD=SPRDS
C-----------------------------------------------------------------------
C TITLE OF FIGURE
C-----------------------------------------------------------------------
      MESG=MESN
      IF(LMTRIX) MESG=MESM
      WRITE (6,611) (ZTXT(II),II=1,9),ENGY,SPRD,NUS,SGMZ,BETAC,
     1 NDATE,NTIME,MESG,REVFRQ,ALPH0,CHROM,FREQ,RS,QV,LZOT,LBIN,MU
C-----------------------------------------------------------------------
      IF(LPLE) CALL TOPLO3(ZTXT,NDATE,NTIME,NUS,ENGY,SGMZ,BETAC,REVFRQ,
     1 ALPH0,CHROM,FREQ,RS,QV,SPRD,LBIN,MU,TT,QXYMM)
      DO 81 I=1,NQ
      DO 82 N=1,NCR
      EFI(N)=-EIGI(I,N)
      IF (STPC.LT.0.) EFI(N)=-EIGI(I,NCR-N+1)
      XPNT=CRNT+STPC*DFLOAT(N-1)
      IF(LPLE) WRITE(9,1011) XPNT,EFI(N)
   82 CONTINUE
      IF(LPLE) WRITE(9,1013)
      IPRI=1
      IF(I.EQ.NQ) IPRI=0
      CALL DRPLOT (6,DUMMY,EFI,NCR,LZEIS,0,QXYMM,IPRI)
   81 CONTINUE
      WRITE(6,1042) TT
C-->
  611 FORMAT(1H1,'PROBLEM = ',9A8,10X,
     1'ENGY/GeV=',G10.3,5X,'SPRD=',G10.3/
     11X,75X,'NUS=',G10.3,4X,'SGMZ/cm=',G10.3,2X,'BETAC/m=',G10.3/
     11X,A8,2X,A8,4X,A34,12X,
     1'REVFRQ/MHz=',G10.3,6X,'ALPHA=',G10.3,4X,'CHROM=',G10.3/
     11X,70X,'FREQ/MHz=',G10.3,2X,'RS/MOhm/m=',G10.3,7X,'QV=',G10.3/
     11X,'(*) = Imaginary part of (Nu-Nux)/Nus vs.',
     1' the bunch current (mA)',
     111X,'LZOT=',L1,16X,'LBIN=',L1,16X,'MU=',I3)
      IF(.NOT.LINTGL) STOP
      IF(SPRDS.EQ.0.) STOP
C-----------------------------------------------------------------------
C IMAGINARY PART OF EIGENVALUE FOR NONZERO TUNE SPREAD
C-----------------------------------------------------------------------
      QXYMM(3)=SNGL(TAUMIN)
      QXYMM(4)=SNGL(TAUMAX)
      DO 322 IS=1,NSTPS
      IF(SPRD0.EQ.0.) SPRD=SPRDS*DFLOAT(IS)/DFLOAT(NSTPS)
      IF(SPRD0.NE.0.) SPRD=SPRD0+(SPRDS-SPRD0)*DFLOAT(IS-1)/
     & DFLOAT(NSTPS-1)
C-----------------------------------------------------------------------
C TITLE OF FIGURE
C-----------------------------------------------------------------------
      WRITE (6,611) (ZTXT(II),II=1,9),ENGY,SPRD,NUS,SGMZ,BETAC,
     1 NDATE,NTIME,MESD,REVFRQ,ALPH0,CHROM,FREQ,RS,QV,LZOT,LBIN,MU
C-----------------------------------------------------------------------
      IF(LPLE) CALL TOPLO3(ZTXT,NDATE,NTIME,NUS,ENGY,SGMZ,BETAC,REVFRQ,
     1 ALPH0,CHROM,FREQ,RS,QV,SPRD,LBIN,MU,TT,QXYMM)
      IF(LPLE) WRITE(9,1041)
      DO 83 I=1,NE
      DO 84 N=1,NCR
      EFI(N)=-SNGL(ESTI(I,N,IS))
      IF (STPC.LT.0.) EFI(N)=-SNGL(ESTI(I,NCR-N+1,IS))
      XPNT=CRNT+STPC*DFLOAT(N-1)
      IF(LPLE) WRITE(9,1011) XPNT,EFI(N)
   84 CONTINUE
      IF(LPLE) WRITE(9,1015)
      IPRI=1
      IF(I.EQ.NE) IPRI=0
      CALL DRPLOT (6,DUMMY,EFI,NCR,LZEIS,0,QXYMM,IPRI)
   83 CONTINUE
      WRITE(6,1042) TT
  322 CONTINUE
C-->
      STOP
      END
C
      REAL FUNCTION FSGM*8(X)
C-----------------------------------------------------------------------
C BUNCH LENGTH AS A FUNCTION OF CURRENT
C YOU SHOULD DEFINE IT AS YOU WANT
C CATION!
C FSGM=SIGMAZ(cm)/RADIUS OF MACHINE
C RAD IS DEFINED IN UNIT OF cm HERE, SO YOU CAN USE IT DIRECTRL
C CURRENT IS IN UNIT OF MILI AMP.
C
C     IF SGMZ>0, BUNCH LENGTH IS CONSTANT.
C     IF SGMZ=0, BUNCH LENGTH VARIES WITH CURRENT AS INPUT WAY.
C     IF SGMZ<0, BUNCH LENGTH VARIES ACCORDING TO THE DEFINED FUNCTION.
C
C     X:CURRENT (mili. AMP.)
C-----------------------------------------------------------------------
      PARAMETER (NCM=1005)
      IMPLICIT REAL*8(A-H,O-Z)
      COMMON /COM/ SGM,RAD,SGMTOC(NCM),CTOSGM(NCM)
      IF(SGM) 1,2,3
    1 IF(X.GT.0.0) FSGM=3.127D0*X**0.33333333/RAD
      IF(X.EQ.0.0) FSGM=4.9638/RAD
      RETURN
    2 I=1
    4 IF(I.GE.NCM) GO TO 5
      IF(CTOSGM(I).GE.X) GO TO 10
      I=I+1
      GO TO 4
   10 A=(SGMTOC(I)-SGMTOC(I-1))/(CTOSGM(I)-CTOSGM(I-1))
      B=SGMTOC(I)-CTOSGM(I)*A
      FSGM=(A*X+B)/RAD
      RETURN
    3 FSGM=SGM
      RETURN
    5 FSGM=0.0
      RETURN
      END
C
      REAL FUNCTION FNUS*8(X)
C-----------------------------------------------------------------------
C SYNCHROTRON TUNE AS A FUNCTION OF CURRENT
C YOU SHOULD DEFINE IT AS YOU WANT
C CATION!
C
C     IF NUS>0, SYNCHROTRON TUNE IS CONSTANT.
C     IF NUS=0, SYNCHROTRON TUNE VARIES WITH CURRENT AS INPUT WAY.
C     IF NUS<0, SYNCHROTRON TUNE VARIES ACCORDING TO THE DEFINED FUNCTIO
C
C     X:CURRENT (mili. AMP.)
C-----------------------------------------------------------------------
      PARAMETER (NCM=1005)
      IMPLICIT REAL*8(A-H,O-Z)
      REAL*8 NUS,NUSTOC
      COMMON /CON/ NUS,NUSTOC(NCM),CTONUS(NCM)
      IF(NUS) 1,2,3
    1 FNUS=-NUS
      RETURN
    2 I=1
    4 IF(I.GE.NCM) GO TO 5
      IF(CTONUS(I).GE.X) GO TO 10
      I=I+1
      GO TO 4
   10 A=(NUSTOC(I)-NUSTOC(I-1))/(CTONUS(I)-CTONUS(I-1))
      B=NUSTOC(I)-CTONUS(I)*A
      FNUS=A*X+B
      RETURN
    3 FNUS=NUS
      RETURN
    5 FNUS=0.0
      RETURN
      END
C
      COMPLEX FUNCTION DET*16(X)
C-----------------------------------------------------------------------
C     DETERMINANT OF MATRIX FOR DISPERSION INTEGRAL METHOD
C-----------------------------------------------------------------------
      PARAMETER (NM=500)
      IMPLICIT REAL*8(A-H,O-Z)
      LOGICAL*1 LMTRIX
      INTEGER*4 INDEX(NM,3)
      COMPLEX*16 AM,X,TAU,FM(NM),FF,A(NM,NM),ZEZE1
      COMPLEX*16 T,SWAP,PIVOT
      REAL*8 NUSV
      EQUIVALENCE (T,SWAP)
      EXTERNAL ZEZE1
      COMMON /TUNE/ NUSV,SPRD,LMTRIX
      COMMON /MTRX/ AM(NM,NM)
      COMMON /MPA/ NMODE,NMODF,KRAD
      NE=(KRAD+1)*(NMODE-NMODF+1)
      DO 10 M=NMODF,NMODE
      TAU=-NUSV*(X-DFLOAT(M))/(2.D0*SPRD)
      FF=NUSV*(1.D0-ZEZE1(-TAU))/(2.D0*SPRD)
      IF(FF.EQ.0.D0) FF=0.001D0
      FM(M-NMODF+1)=FF
   10 CONTINUE
      DO 900 M=NMODF,NMODE
      DO 900 K=0,KRAD
      DO 910 N=NMODF,NMODE
      DO 910 L=0,KRAD
      MM=K+(M-NMODF)*(KRAD+1)+1
      NN=L+(N-NMODF)*(KRAD+1)+1
      A(MM,NN)=AM(MM,NN)
      IF((M.EQ.N).AND.(K.EQ.L)) A(MM,NN)=AM(MM,NN)-DFLOAT(M)
     & -1.D0/FM(M-NMODF+1)
  910 CONTINUE
  900 CONTINUE
C-----------------------------------------------------------------------
C NOW DETERMINANT
C-----------------------------------------------------------------------
      N=NE
      DET=1.D0
      DO 20 J=1,N
   20 INDEX(J,3)=0
      DO 550 I=1,N
      AMAX=0.D0
      DO 105 J=1,N
      IF(INDEX(J,3)-1) 60, 105, 60
   60 DO 100 K=1,N
      IF(INDEX(K,3)-1) 80, 100, 715
   80 IF(AMAX-CDABS(A(J,K))) 85, 100, 100
   85 IROW=J
      ICOLUM=K
      AMAX=CDABS(A(J,K))
  100 CONTINUE
  105 CONTINUE
      INDEX(ICOLUM,3)=INDEX(ICOLUM,3)+1
      INDEX(I,1)=IROW
      INDEX(I,2)=ICOLUM
C
      IF(IROW-ICOLUM) 140, 310, 140
  140 DET=-DET
      DO 200 L=1,N
      SWAP=A(IROW,L)
      A(IROW,L)=A(ICOLUM,L)
  200 A(ICOLUM,L)=SWAP
C
  310 PIVOT=A(ICOLUM,ICOLUM)
      DET=DET*PIVOT
      A(ICOLUM,ICOLUM)=1.D0
      DO 350 L=1,N
  350 A(ICOLUM,L)=A(ICOLUM,L)/PIVOT
C
      DO 550 L1=1,N
      IF(L1-ICOLUM) 400, 550, 400
  400 T=A(L1,ICOLUM)
      A(L1,ICOLUM)=0.D0
      DO 450 L=1,N
  450 A(L1,L)=A(L1,L)-A(ICOLUM,L)*T
  550 CONTINUE
  715 CONTINUE
      RETURN
      END
C
      REAL FUNCTION ABSDET*4(X)
C-----------------------------------------------------------------------
C     ABSOLUTE VALUE OF DETERMINANT FOR MAP
C-----------------------------------------------------------------------
      IMPLICIT REAL*4(A-H,O-Z)
      COMPLEX*16 DET,Z
      Z=DCMPLX(DBLE(X),0.D0)
      ABSDET=SNGL(CDABS(DET(Z)))
      RETURN
      END
C
      REAL FUNCTION FUN*8(X)
C-----------------------------------------------------------------------
C     ABSOLUTE VALUE OF DETERMINANT FOR $DOFSM (SIMPLEX METHOD)
C-----------------------------------------------------------------------
      PARAMETER (NM=500)
      IMPLICIT REAL*8(A-H,O-Z)
      LOGICAL*1 LDIV
      REAL*8 X(2)
      COMPLEX*16 DET,Z
      COMMON /SOL/ SOLR(NM),SOLI(NM),NOTH,LDIV
      Z=DCMPLX(X(1),X(2))
      FUN=CDABS(DET(Z))
      IF (.NOT.LDIV) RETURN
      DO 1 I=1,NOTH-1
    1 FUN=FUN/CDABS((Z-DCMPLX(SOLR(I),SOLI(I))))**2
      RETURN
      END
C
      REAL FUNCTION DMX*8(M,N)
C-----------------------------------------------------------------------
C     DISPERSION MATRIX FOR BETATRON TUNE SPREAD
C-----------------------------------------------------------------------
      IMPLICIT REAL*8(A-H,O-Z)
      LOGICAL*1 LMTRIX
      REAL*8 NUSV
      COMMON /TUNE/ NUSV,SPRD,LMTRIX
      DMX=0.
      IF (.NOT.LMTRIX) RETURN
      FM=DFLOAT(M)
      FN=DFLOAT(N)
      AMN=DSQRT((FM+1.)*(FN+1.))
      IF(M.EQ.N) DMX=-(FM+1.)*4.*SPRD/NUSV
      IF(M-1.EQ.N) DMX=2.*AMN*SPRD/NUSV
      IF(M+1.EQ.N) DMX=2.*AMN*SPRD/NUSV
      RETURN
      END
C
      COMPLEX FUNCTION FINT*16(Z)
C-----------------------------------------------------------------------
C     FUNCTION Z**IORD*EXP(-Z**2)
C-----------------------------------------------------------------------
      IMPLICIT REAL*8(A-H,O-Z)
      COMPLEX*16 Z,ANU,PSG
      COMMON /INT/ ANU,SGMV,CHROM,ALPHA,MU,IORD,MM,NN
      DATA D2/1.41421356D0/
      PSG=(Z-CHROM/ALPHA)*SGMV
      FINT=(PSG/D2)**IORD*CDEXP(-PSG**2)/(Z-ANU)
      RETURN
      END
C
      REAL FUNCTION FRT*8(X,I)
C-----------------------------------------------------------------------
C     FUNCTION Z**IORD*EXP(-Z**2)
C-----------------------------------------------------------------------
      IMPLICIT REAL*8(A-H,O-Z)
      COMPLEX*16 ANU
      COMMON /INT/ ANU,SGMV,CHROM,ALPHA,MU,IORD,MM,NN
      DATA TEPS/1.D-8/
      DATA D2/1.41421356D0/
      PSG=X*SGMV
      FRT=(PSG/D2)**IORD*DEXP(-PSG**2)-TEPS
      RETURN
      END
C
      COMPLEX FUNCTION FBIN*16(Z)
C-----------------------------------------------------------------------
C     FUNCTION J(M+2K+MU+1)*J(N+2L+MU+1)/(P*SGM)**(2*MU+2)
C-----------------------------------------------------------------------
      IMPLICIT REAL*8(A-H,O-Z)
      COMPLEX*16 Z,ANU
      COMMON /INT/ ANU,SGMV,CHROM,ALPHA,MU,IORD,MM,NN
      COMMON /FBI/ EMN
      X=DREAL(Z)
      PSG=(X-CHROM/ALPHA)*SGMV*DSQRT(DFLOAT(2*(MU+2)))
      NMAX=MM+MU+1
      BJ1=BESSJ(NMAX,PSG)
      NMAX=NN+MU+1
      BJ2=BESSJ(NMAX,PSG)
      FBIN=EMN*BJ1*BJ2*(1.D0/PSG)**(2+2*MU)/(Z-ANU)
      RETURN
      END
C
      COMPLEX FUNCTION ZEZE1*16(Z)
C-----------------------------------------------------------------------
C     FUNCTION Z*EXP(Z)*E1(Z) (E1:EXPONENTIAL INTEGRAL)
C-----------------------------------------------------------------------
      IMPLICIT REAL*8(A-H,O-Z)
      COMPLEX*16 Z,EZE1,AEZE1,DN0
      DATA A1/0.711093D0/,A2/0.278518D0/,A3/0.010389D0/
      DATA B1/0.415775D0/,B2/2.29428D0/,B3/6.2900D0/
      DATA EUL/0.5772156649D0/,PI/3.1415927D0/
      REPS=1.D-8
      GEPS=1.D-8
      DR=DREAL(Z)
      DG=DIMAG(Z)
      IF(DR.EQ.0.D0.AND.DG.EQ.0.D0) THEN
C     ZEZE1=EUL
      ZEZE1=0.D0
      ELSE
      IF(DR.LE.0.D0.AND.DG.EQ.0.D0) THEN
      EXPI=DEXPIN(DR)
      ZEZE1=(EXPI-(0.D0,1.D0)*PI)*CDEXP(Z)*Z
      ELSE
      IF(DR.GE.0.D0.AND.DG.EQ.0.D0) THEN
      EXPI=DEXPIN(DR)
      ZEZE1=EXPI*CDEXP(Z)*Z
      ELSE
      IF(DABS(DR).GT.10.D0.OR.DABS(DG).GT.10.D0) GO TO 20
      EZE1=-EUL-CDLOG(Z)
      DN0=(1.D0,0.D0)
      DO 10 N=1,100
      DN=DFLOAT(N)
      DN0=DN0*(-Z)/DN
      AEZE1=-DN0/DN
      EZE1=EZE1+AEZE1
      REZE1=DREAL(EZE1)
      GEZE1=DIMAG(EZE1)
      RAEZE1=DREAL(AEZE1)
      GAEZE1=DIMAG(AEZE1)
      RRATIO=DABS(REZE1)*REPS
      GRATIO=DABS(GEZE1)*GEPS
      IF(RRATIO.GT.DABS(RAEZE1).AND.GRATIO.GT.DABS(GAEZE1)) GO TO 30
   10 CONTINUE
   20 ZEZE1=(A1/(Z+B1)+A2/(Z+B2)+A3/(Z+B3))*Z
      GO TO 15
   30 ZEZE1=EZE1*CDEXP(Z)*Z
      END IF
      END IF
      END IF
   15 Z0=DIMAG(Z)
      RETURN
      END
C
      SUBROUTINE DOFSM (FUNC,X0,N,NX0,MX0,ALPHA,EPS,ITMAX,IOPT,X,F,IER)
C
C-----------------------------------------------------------------------
C
C   S-1511-1 COPYRIGHT HITACHI,LTD. 1980
C
C   NAME                - $DOFSM : DOUBLE PRECISION
C
C   USAGE               - CALL $DOFSM(FUNC,X0,N,NX0,MX0,ALPHA,EPS,ITMAX
C                                      ,IOPT,X,F,IER)
C
C   FUNCTION            - BY THE SIMPLEX METHOD, WE OBTAIN THE EXTREMUM
C                           OF THE GIVEN N-VARIABLE FUNCTION.
C
C   ARGUMENTS  FUNC     - FUNCTION NAME.
C                           FUNC MUST BE DEFINED AS A FUNCTION SUBPROG-
C                           RAM WHICH REQUIRES THE EXTERNAL DECLARATION
C                           IN THE MAIN PROGRAM.
C              X0(NX0,  - INPUT. ASSUME THAT THE COORDINATES OF THE
C                  MX0)     INITIAL SIMPLEX VERTEX ARE
C                              (X1,X2,...,XN)
C                              (X1+E1,X2,...,XN)
C                              (X1,X2+E2,...,XN)
C                              (X1,X2,...,XN+EN)
C                           THEN, X1,X2,...,XN ARE SET TO X0(I,1) (I=1,
C                           ...,N), AND E1,E2,...,EN ARE SET TO
C                           X0(I,N+1) (I=1,...,N).
C                           NONE MAY BE SET TO
C                           X0(I,2),...,X0(I,N) (I=1,...,N).
C                         OUTPUT. COORDINATES OF THE LAST SIMPLEX
C                           VERTEX.
C              N        - INPUT. NUMBER OF VARIABLES (1<=N<=100).
C              NX0      - INPUT. NUMBER OF ROWS OF X0 IN THE DIMENSION
C                           STATEMENT OF A MAIN PROGRAM (NX0>=N).
C              MX0      - INPUT. NUMBER OF COLUMNS OF X0 IN THE DIMENS-
C                           ION STATEMENT OF A MAIN PROGRAM (MX0>=N+1).
C              ALPHA(3) - INPUT. FIRST ELEMENT ; REFLECTION PARAMETER.
C                           SECOND ELEMENT ; CONTRACTION PARAMETER.
C                           THIRD ELEMENT ; EXPANSION PARAMETER.
C              EPS(2)   - INPUT. CRITERION FOR CONVERGENCE OF SOLUTION.
C                           FIRST ELEMENT ; CRITERION FOR CONVERGENCE
C                           OF FUNCTION VALUE.
C                           SECOND ELEMENT ; CRITERION FOR CONVERGENCE
C                           OF VALUES OF INDEPENDENT VARIABLES.
C              ITMAX    - INPUT. ALLOWABLE NUMBER OF ITERATIONS.
C                         OUTPUT. NUMBER OF ITERATIONS PRACTICALLY
C                           CARRIED OUT.
C              IOPT     - INPUT. PARAMETER INDICATING WHETHER THE LOCAL
C                           MAXIMUM OR MINIMUM IS OBTAINED.
C                           LOCAL MAXIMUM IF IOPT=1.
C                           LOCAL MINIMUM IF IOPT=2.
C              X(N)     - OUTPUT. COORDINATES OF THE POINT WHERE THE
C                           EXTREMUM IS OBTAINED.
C              F        - OUTPUT. EXTREMUM OF THE FUNCTION.
C              IER      - ERROR INDICATOR.
C                           IER=   0,NO ERROR WAS DETECTED.
C                           IER=2000,THE INPUT PARAMETERS ARE INVALID.
C                           IER=3000,NOT CONVERGED DESPITE THE SPECIFIED
C                                    NUMBER OF ITERATIONS.
C                           IER=3100,THE EXTREMUM WAS NOT OBTAINED
C                                    BECAUSE OF TOO LARGE SIMPLEX.
C
C   REQD. USER PROGRAM  - FUNC (X) : DOUBLE PRECISION
C                           THE ARGUMENT IS
C                               X(N); INDEPENDENT VARIABLES OF
C                                     THE FUNCTION X1,X2,...,XN.
C   REQD. SUBPROGRAM    - $SUERM, $SURTM
C
C   STATUS              - S-1511-1 02-00
C
C   HISTORY             - DATE.    1979.12
C                                  1980.11
C
C-----------------------------------------------------------------------
C
C   S-1511-1 COPYRIGHT HITACHI,LTD. 1980
C
      IMPLICIT REAL*8 (A-H,O-Z)
      REAL*8 ALP,ALP1,BET,BET1,GAM,GAM1,WORK1,WORK2
C     GENERIC
      DIMENSION  X0(NX0,MX0),ALPHA(3),EPS(2),X(N),XR(100),FF(101)
      DATA ZERO,ONE,ONE15     / 0.0D0   , 1.0D0   , 1.0D15           /
      DATA ONE70,ONE75,FIVE1  / 1.0D-20 , 1.0D25  , 5.0D-1           /
C
C     *** ARGUMENT CHECK AND PREPARATION ***
      ISET=0
      IER = 0
      IF( N.GT.0 .AND. N.LE.100 ) GO TO 10
   10 N1  = N+1
      IF(NX0.GE.N .AND. MX0.GE.N1) GO TO 20
   20 JER=0
      DO 30 I=1,3
   30 IF( ALPHA(I).LT.-ONE70 ) JER=1
      IF( JER.EQ.0 ) GO TO 50
   40 CONTINUE
      GO TO 60
   50 IF( ALPHA(2).GE.ONE ) GO TO 40
      IF( ALPHA(3).LE.ONE .AND. ALPHA(3).GT.ONE70 ) GO TO 40
      ALP = ALPHA(1)
      BET = ALPHA(2)
      GAM = ALPHA(3)
      IF(DABS(ALPHA(1)).LE.ONE70) ALP=1.D0
      IF(DABS(ALPHA(2)).LE.ONE70) BET=5.D-1
      IF(DABS(ALPHA(3)).LE.ONE70) GAM=2.D0
   60 IF( EPS(1).GT.-ONE70 .AND. EPS(2).GT.-ONE70 ) GO TO 80
   70 CONTINUE
      GO TO 140
   80 IF( DABS(EPS(1))-ONE70 ) 90,90,110
   90 IF( DABS(EPS(2))-ONE70 ) 70,70,100
  100 IEPS = 2
      GO TO 140
  110 IF( DABS(EPS(2))-ONE70 ) 120,120,130
  120 IEPS = 1
      GO TO 140
  130 IEPS = 3
  140 IF( ITMAX ) 160,160,170
  160 NSTOP = 500
      GO TO 180
  170 NSTOP = ITMAX
  180 IF( N.LE.0 .OR. N.GT.100 ) GO TO 195
      DO 190 I=1, N
      IF( DABS( X0(I,N1) ).GT.ONE70 ) GO TO 190
  190 CONTINUE
C 195 IF( IER.EQ.0 ) GO TO 197
  195 CONTINUE
C     GO TO 9999
C
C
C     *** SET THE VERTICES OF THE INITIAL SIMPLEX ***
  197 DO 210 I=2, N1
         I1 = I-1
         DO 210 J=1, N
         IF( I1.EQ.J ) GO TO 200
         X0(J,I) = X0(J,1)
         GO TO 210
  200    X0(J,I) = X0(J,1) + X0(J,N1)
  210 CONTINUE
      ICODE = 1
      NIT   = 1
C
C     *** BEGINNING OF THE LOOP FOR THE SIMPLEX METHOD ***
  220 IF( NIT.LE.NSTOP ) GO TO 230
      NIT = NIT-1
      ISET=3000
      IF( ICODE ) 640, 640, 235
C
C     *** VALUES OF THE FUNCTION AT THE VERTICES ***
  230 IF( ICODE.EQ.0 ) GO TO 300
  235 DO 270 I=1, N1
         DO 240 J=1, N
  240 X(J) = X0(J,I)
      IF( IOPT.EQ.1 ) GO TO 260
  250 FF(I) = FUNC(X)
         GO TO 270
  260 FF(I) = -FUNC(X)
  270 CONTINUE
      ICODE = 0
C
C     *** FIND THE MAXIMUM AND MINIMUM POINTS ***
  300 IMAX = 1
      IMIN = 1
      FMAX = FF(1)
      F = FF(1)
      DO 340 I=2, N1
         IF( FF(I)-FMAX ) 320, 320, 310
  310    FMAX = FF(I)
         IMAX = I
         GO TO 340
  320 IF( FF(I)-F ) 330,340,340
  330 F = FF(I)
         IMIN = I
  340 CONTINUE
      IF(ISET.EQ.3000) GO TO 645
C
C     *** CALCULATE THE CENTROID OF THE POINTS WITH I.NE.IMAX ***
      DO 360 J=1, N
         SUM = ZERO
         DO 350 I=1, N1
  350    SUM = SUM + X0(J,I)
         X(J)=(SUM-X0(J,IMAX))/N
  360 CONTINUE
C
C     *** REFLECTION OF THE MAXIMUM POINT ***
      ALP1 = ALP+ONE
      DO 370  J=1,N
         WORK1=X(J)
      WORK2=X0(J,IMAX)
      XR(J)=ALP1*WORK1-ALP*WORK2
  370 CONTINUE
      FR   =  FUNC(XR)
      IF( IOPT.EQ.1 ) FR = -FR
C
C     *** SEE IF FUNC(REFLEC)<FF ***
      IF( FR-F ) 420,380,380
C
C     *** FIND THE NEXT MAXIMUM POINT (WHEN  FUNC(REFLEC).GE.FF ) ***
  380 FSMAX = -ONE75
      DO 390 I=1, N1
         IF( I.EQ.IMAX ) GO TO 390
         IF( FF(I).LE.FSMAX ) GO TO 390
         FSMAX = FF(I)
  390 CONTINUE
C
C     *** SEE IF FUNC(REFLEC)>FSMAX ***
      IF( FR-FSMAX ) 400, 400, 460
  400 FF(IMAX) = FR
      DO 410 J=1, N
  410 X(J) = XR(J)
      GO TO 445
C
C     *** EXPANSION OF THE REFLECTION (WHEN  FUNC(REFLEC).LT.FF ) ***
  420 GAM1 = ONE-GAM
      DO 430  J=1,N
      WORK1=XR(J)
      WORK2 = X(J)
      X(J) = GAM*WORK1 + GAM1*WORK2
  430 CONTINUE
      FE = FUNC(X)
      IF( IOPT.EQ.1 ) FE=-FE
C
C     *** SEE IF FUNC(EXPANS)<FUNC(REFLEC) ***
      IF( FE-FR ) 440, 400, 400
  440 FF(IMAX) = FE
C
C     *** REPLACE THE MAXIMUM POINT WITH A NEW VERTEX ***
  445 DO 450 J=1, N
  450 X0(J,IMAX) = X(J)
      GO TO 500
C
C     *** IN CASE OF FUNC(REFLEC)>FSMAX ***
  460 IF( FR.GE.FMAX ) GO TO 480
      DO 470 J=1, N
  470 X0(J,IMAX) = XR(J)
C
C     *** CONTRACTION OF THE MAXIMUM POINT OR OF ITS REFLECTION ***
  480 BET1 = ONE-BET
      DO 490  J=1,N
      WORK1=X0(J,IMAX)
      WORK2 = X(J)
      X(J) = BET*WORK1 + BET1*WORK2
  490 CONTINUE
      FC = FUNC(X)
      IF( IOPT.EQ.1 ) FC=-FC
C
C     *** SEE IF FUNC(CONTRAC)>FMAX ***
      IF( FC-FMAX ) 495, 620, 620
  495 FF(IMAX) = FC
      GO TO 445
C
C     *** CONVERGENCE CHECK ***
  500 GO TO (520, 550, 520 ), IEPS
  520 SUM2=0.D0
      SUM=0.D0
      DO 530 I=1,N1
      SUM=SUM+FF(I)
  530 CONTINUE
      SUM=SUM/N1
      DO 535 I=1,N1
      SUM2=(FF(I)-SUM)**2+SUM2
  535 CONTINUE
      SD=DSQRT(SUM2/N1)
      IF( SD-EPS(1) ) 540, 540, 550
  540 IF( IEPS.EQ.1 ) GO TO 640
      IEPS = 4
  550 AINTM = -ONE75
      DO 580 I=1, N
         I1 = I+1
         DO 570 K=I1, N1
            DO 560 J=1, N
            AINT = DABS( X0(J,I)-X0(J,K) )
  560       IF( AINT.GT.AINTM ) AINTM = AINT
  570    CONTINUE
  580 CONTINUE
      GO TO ( 600, 590, 600, 590 ), IEPS
  590 IF( AINTM.LE.EPS(2) ) GO TO 640
  600 IF( AINTM.GT.ONE15 ) GO TO 680
      IF( IEPS.EQ.4 ) IEPS = 3
  610 NIT = NIT+1
      GO TO 220
C
C     *** REDUCE THE SIMPLEX SIZE ***
  620 ICODE = 1
      DO 630 I=1, N1
      DO 630 J=1, N
  630 X0(J,I) = FIVE1*( X0(J,I)+X0(J,IMIN) )
      GO TO 610
C
C     *** TERMINATE ***
  640 IF( F.GT.FF(IMAX) ) GO TO 660
  645 DO 650 J=1, N
  650 X(J) = X0(J,IMIN)
      GO TO 690
  660 F = FF(IMAX)
      GO TO 690
  680 ISET=3100
  690 ITMAX = NIT
      IF( IOPT.EQ.1 ) F=-F
      IF(ISET.EQ.0) GO TO 9999
      IER=ISET
 9999 CONTINUE
      RETURN
C
      END
C
      SUBROUTINE ZNTMM (FUNC,X0,ZEPS,FEPS,ITMAX,X,IER)
C
C----------------------------------------------------------------------
C
C   S-1511-1 COPYRIGHT HITACHI,LTD. 1980
C
C   NAME                - $ZNTMM : DOUBLE PRECISION
C
C   USAGE               - CALL $ZNTMM (FUNC,X0,ZEPS,FEPS,ITMAX,X,IER)
C
C   FUNCTION            - BY THE MULLER METHOD, WE OBTAIN THE NUMERICAL
C                           SOLUTION OF A COMPLEX TRANSCENDENTAL EQUA-
C                           TION.
C
C   ARGUMENTS  FUNC     - FUNCTION NAME.
C                           FUNC MUST BE DEFINED AS A FUNCTION SUBPRO-
C                           GRAM THAT REQUIRES THE EXTERNAL DECLARATION
C                           IN THE MAIN PROGRAM.
C              X0       - INPUT. THE STARTING VALUE.
C              ZEPS     - INPUT. CRITERION FOR CONVERGENCE OF VARIABLE
C                           (ZEPS>=0.0).
C              FEPS     - INPUT. CRITERION FOR CONVERGENCE OF FUNCTION
C                           VALUE (FEPS>=0.0).
C              ITMAX    - INPUT. ALLOWABLE NUMBER OF ITERATIONS
C                           (ITMAX>=1).
C                         OUTPUT. NUMBER OF ITERATIONS PRACTICALLY
C                           CARRIED OUT.
C              X        - OUTPUT. A COMPLEX ROOT OBTAINED.
C              IER      - ERROR INDICATOR.
C                           IER=   0, NO ERROR WAS DETECTED.
C                           IER=1000, ZEPS IS TOO SMALL.
C                           IER=2000, ZEPS<0, FEPS<0 OR ITMAX<1.
C                           IER=3000, NOT CONVERGED DESPITE THE SPECI-
C                                     FIED NUMBER OF ITERATIONS.
C                           IER=3100, THE ITERATION IS DIVERGING.
C                           IER=3200, LACK OF GOOD PROGRESS.
C                           IER=3300, A PERTURBATION BEEN EXECUTED IN
C                                     CASE OF XI=XI-1=XI-2 OR
C                                     F(XI)=F(XI-1)=F(XI-2),
C                                     BUT AGAIN BECOMES SAME CONDITION.
C   REQD. USER SUBPROG. - FUNC(X) : DOUBLE PRECISION
C                           THE ARGUMENT IS
C                               X ; VARIABLE.
C   REQD. MSLII SUBPROG.- $SUERM, $SURTM
C
C   STATUS              - S-1511-1 02-00
C
C   HISTORY             - DATE.    1980.11
C
C----------------------------------------------------------------------
C
      IMPLICIT REAL*8(A,B,E-H,O-Z),COMPLEX*16(C,D)
      EXTERNAL FUNC
      COMPLEX*16 X0,X,FUNC
C     GENERIC
      DATA UEPS/Z3410000000000000/
      DATA C11,C1M1/(1.0D0,1.0D0),(1.0D0,-1.0D0)/
      DATA ZERO,ONE,TWO,FOUR,TEN/0.0D0,1.0D0,2.0D0,4.0D0,10.0D0/
C
      IER=0
      IER1=0
      IF (ZEPS.LT.ZERO) GO TO 280
      IF (FEPS.LT.ZERO) GO TO 280
      IF (ITMAX.LT.1) GO TO 280
C
      UEPSI=SQRT(UEPS)
      CUP=CMPLX(ONE,UEPSI)
      CUM=CMPLX(ONE,-UEPSI)
      NTS=0
      NDIV=0
      NLGP=0
      NPTV=0
      ITM=ITMAX+1
      IF (ABS(X0).NE.ZERO) GO TO 10
         DX1=UEPSI*C11
         DX2=UEPSI*C1M1
         DX3=UEPSI
         ZMAX=TEN
         GO TO 20
C
   10    DX1=X0*CUP
         DX2=X0*CUM
         DX3=X0
         ZMAX=ABS(X0)*TEN
   20 DF1=FUNC(DX1)
      DF2=FUNC(DX2)
      DF3=FUNC(DX3)
C
      DO 270 IT=1,ITM
   30    D1=DX3-DX2
         TOL=ABS(DX3)
         IF (TOL.EQ.ZERO) TOL=ONE
         IF (ABS(D1).GT.ZEPS*TOL) GO TO 40
         IF (ABS(DF3).GT.FEPS)  GO TO 40
C
C           CONVERGED
C
            GO TO 290
C
   40    IF (IT.EQ.ITM) GO TO 270
         IF (ABS(DF3-DF2).NE.ZERO) GO TO 80
         IF (ABS(DF2-DF1).NE.ZERO) GO TO 80
   45       IF (NPTV.NE.1) GO TO 50
               IER1=3300
               GO TO 290
C
C              PERTURBATION
C
   50          NPTV=1
               IF (ABS(DX3).NE.ZERO) GO TO 60
                  DX1=UEPSI*C11
                  DX2=UEPSI*C1M1
                  DX3=UEPSI
                  DF3=FUNC(DX3)
                  GO TO 70
C
   60             DX1=DX3*CUP
                  DX2=DX3*CUM
   70          DF1=FUNC(DX1)
               DF2=FUNC(DX2)
               GO TO 30
C
   80    IF (ABS(D1).LE.UEPSI*TOL) GO TO 90
            NTS=0
            GO TO 110
C
   90       IF (NTS.NE.3) GO TO 100
C
C              ZEPS IS TOO SMALL
C
               IER1=1000
               IER=1000
               GO TO 290
C
  100          NTS=NTS+1
  110    D2=DX2-DX1
         IF (ABS(DF3).LT.ABS(DF2)) GO TO 130
         IF (ABS(D1).LT.ABS(D2)) GO TO 130
            IF (NDIV.NE.2) GO TO 120
C
C              DIVERGENCE OF THE ITERATION
C
               IER1=3100
               IER=3100
               GO TO 290
C
  120          NDIV=NDIV+1
               GO TO 140
C
  130       NDIV=0
  140    IF (ABS(DF3).GE.ABS(DF2)) GO TO 150
         IF (ABS(D1).GE.ABS(D2)) GO TO 150
            NLGP=0
            GO TO 170
C
  150       IF (NLGP.NE.4) GO TO 160
C
C              LACK OF GOOD PROGRESS
C
               IER1=3200
               IER=3200
               GO TO 290
C
  160          NLGP=NLGP+1
  170    D3=DX3-DX1
         IF (ABS(D1).EQ.ZERO .AND. ABS(D2).EQ.ZERO) GO TO 45
         IF (ABS(D1).EQ.ZERO) GO TO 180
         IF (ABS(D2).EQ.ZERO) GO TO 180
         IF (ABS(D3).EQ.ZERO) GO TO 190
            GO TO 200
C
  180       D1=(DF3-DF1)/D3
            GO TO 230
C
  190       D1=(DF3-DF2)/D1
            GO TO 230
C
  200    D1=(DF3-DF2)/D1
         D2=(DF2-DF1)/D2
         D3=(D1-D2)/D3
C
         IF (ABS(D3).EQ.ZERO) GO TO 230
            DOMEGA=D1+(DX3-DX2)*D3
            DW=SQRT(DOMEGA**2-FOUR*DF3*D3)
            DY=DOMEGA+DW
            IF (ABS(DY).GE.ABS(DOMEGA-DW)) GO TO 210
               DY=DOMEGA-DW
  210       IF (ABS(DY).NE.ZERO) GO TO 220
               GO TO 45
C
  220       DX=-TWO*DF3/DY
            GO TO 240
C
  230       DX=-DF3/D1
  240    DX4=DX3+DX
         IF (ABS(DX).LE.ZMAX) GO TO 250
            DX=DX/ABS(DX)*ZMAX
            DX4=DX3+DX
  250    IF (ZMAX.GT.TEN*ABS(DX4)) GO TO 260
           ZMAX=TEN*ABS(DX4)
  260    DX1=DX2
         DX2=DX3
         DX3=DX4
         DF1=DF2
         DF2=DF3
         DF3=FUNC(DX4)
  270 CONTINUE
C
C     NO CONVERGENCE IN ITMAX
C
      IER1=3000
      IER=3000
      GO TO 300
C
C
C     PARAMATER ERROR
C
  280 IER1=2000
      IER=2000
      GO TO 310
C
  290 ITMAX=IT-1
      IF (ITMAX.NE.0) GO TO 300
         ITMAX=1
  300 X=DX3
      IF (IER1.EQ.0) GO TO 9999
  310 CONTINUE
 9999 RETURN
      END
C
C******************** CWERF ****************************************
C COMPLEX ERROR FUNCTION
C*******************************************************************
      FUNCTION CWERF(Z)
      IMPLICIT REAL*8 (A-H,O-Z)
      COMPLEX*16 Z,CWERF
      LOGICAL B
      DATA CONST/1.12837 91670 9551D0/
      XX=REAL(Z)
      YY=DIMAG(Z)
      X=ABS(XX)
      Y=ABS(YY)
      IF(Y .LT. 4.29D0 .AND. X .LT. 5.33D0) GO TO 1
      H=0.
      NC=0
      NU=8
      ALAMDA=0.
      B=.TRUE.
      GO TO 2
    1 S=(1D0-Y/4.29D0)*SQRT(1D0-X**2/28.41D0)
      H=1.6D0*S
      H2=2D0*H
      NC=6+INT(23D0*S)
      NU=9+INT(21D0*S)
      ALAMDA=H2**NC
      B= ALAMDA .EQ. 0D0
    2 R1=0D0
      R2=0D0
      S1=0D0
      S2=0D0
      N=NU+1
    3 N=N-1
      FN=N+1
      T1=Y+H+FN*R1
      T2=X-FN*R2
      C=0.5D0/(T1**2+T2**2)
      R1=C*T1
      R2=C*T2
      IF(H .LE. 0.0 .OR. N .GT. NC) GO TO 4
      T1=ALAMDA+S1
      S1=R1*T1-R2*S2
      S2=R2*T1+R1*S2
      ALAMDA=ALAMDA/H2
    4 IF(N .GT. 0) GO TO 3
      IF(B) GO TO 6
      RS1=S1
      RS2=S2
      GO TO 7
    6 RS1=R1
      RS2=R2
    7 RS1=CONST*RS1
      IF(Y .EQ. 0D0) RS1=EXP(-X**2)
      CWERF=DCMPLX(RS1,CONST*RS2)
      IF(YY .LT. 0D0) GO TO 8
      IF(XX .LT. 0D0) CWERF=CONJG(CWERF)
      RETURN
    8 CWERF=2D0*EXP(-DCMPLX(X,Y)**2)-CWERF
      IF(XX .GT. 0D0) CWERF=CONJG(CWERF)
      RETURN
      END
C
      COMPLEX FUNCTION FGAUSS*16(F,A,B,EPS)
C-----------------------------------------------------------------------
C     COMPLEX INTEGRATION ALONG A LINE SEGMENT
C-----------------------------------------------------------------------
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION W(12),X(12)
 
      COMPLEX*16 F,A,B,AA,BB,C1,C2,S8,S16,Y,U
 
      DATA CONST /1.0D-24/
 
      DATA W
     1/0.10122 85362 90376, 0.22238 10344 53374, 0.31370 66458 77887,
     2 0.36268 37833 78362, 0.02715 24594 11754, 0.06225 35239 38648,
     3 0.09515 85116 82493, 0.12462 89712 55534, 0.14959 59888 16577,
     4 0.16915 65193 95003, 0.18260 34150 44924, 0.18945 06104 55069/
 
      DATA X
     1/0.96028 98564 97536, 0.79666 64774 13627, 0.52553 24099 16329,
     2 0.18343 46424 95650, 0.98940 09349 91650, 0.94457 50230 73233,
     3 0.86563 12023 87832, 0.75540 44083 55003, 0.61787 62444 02644,
     4 0.45801 67776 57227, 0.28160 35507 79259, 0.09501 25098 37637/
 
      Y=B-A
      DELS=CONST*(DREAL(Y)**2+DIMAG(Y)**2)
      EPSS=EPS**2
      FGAUSS=0.
      AA=A
    5 Y=B-AA
      IF(DREAL(Y)**2+DIMAG(Y)**2 .LE. DELS) RETURN
    2 BB=AA+Y
      C1=0.5*(AA+BB)
      C2=C1-AA
      S8=0.
      S16=0.
      DO 1 I = 1,4
      U=X(I)*C2
    1 S8=S8+W(I)*(F(C1+U)+F(C1-U))
      DO 3 I = 5,12
      U=X(I)*C2
    3 S16=S16+W(I)*(F(C1+U)+F(C1-U))
      S8=S8*C2
      S16=S16*C2
      S8=S16-S8
      IF(DREAL(S8)**2+DIMAG(S8)**2 .GT. EPSS*(1.0+DREAL(S16)
     1 **2+DIMAG(S16)**2)) GO TO 4
      FGAUSS=FGAUSS+S16
      AA=BB
      GO TO 5
    4 Y=0.5*Y
      IF(DREAL(Y)**2+DIMAG(Y)**2 .GT. DELS) GO TO 2
 
      PRINT 7
      FGAUSS=0.
      RETURN
    7 FORMAT(1X,37HCGAUSS ... TOO HIGH ACCURACY REQUIRED)
 
      END
C
      REAL FUNCTION FACTRL*8(N)
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION A(33)
      DATA NTOP,A(1)/0,1.D0/
      IF (N.LT.0) THEN
      PAUSE 'negative factorial'
      ELSE IF (N.LE.NTOP) THEN
      FACTRL=A(N+1)
      ELSE IF (N.LE.32) THEN
      DO 11 J=NTOP+1,N
      A(J+1)=J*A(J)
   11 CONTINUE
      NTOP=N
      FACTRL=A(N+1)
      ELSE
      FACTRL=DEXP(GAMMLN(REAL(N)+1.D0))
      ENDIF
      RETURN
      END
C
      REAL FUNCTION GAMMLN*8(XX)
      IMPLICIT REAL*8 (A-H,O-Z)
      REAL*8 COF(6),STP,HALF,ONE,FPF,X,TMP,SER
      DATA COF,STP/76.18009173D0,-86.50532033D0,24.01409822D0,
     *    -1.231739516D0,.120858003D-2,-.536382D-5,2.50662827465D0/
      DATA HALF,ONE,FPF/0.5D0,1.0D0,5.5D0/
      X=XX-ONE
      TMP=X+FPF
      TMP=(X+HALF)*DLOG(TMP)-TMP
      SER=ONE
      DO 11 J=1,6
      X=X+ONE
      SER=SER+COF(J)/X
   11 CONTINUE
      GAMMLN=TMP+DLOG(STP*SER)
      RETURN
      END
C
      REAL FUNCTION BESSJ*8(N,X)
C----------------------------------------------------------------------
C BESSEL FUNCTION OF INTEGER ORDER
C----------------------------------------------------------------------
      IMPLICIT REAL*8 (A-H,O-Z)
      PARAMETER (IACC=40,BIGNO=1.D10,BIGNI=1.D-10)
      IF(N-1) 1,2,3
    1 BESSJ=BESSJ0(X)
      RETURN
    2 BESSJ=BESSJ1(X)
      RETURN
    3 AX=DABS(X)
      TOX=2.D0/AX
      IF(AX.GT.FLOAT(N))THEN
      BJM=BESSJ0(AX)
      BJ=BESSJ1(AX)
      DO 11 J=1,N-1
      BJP=J*TOX*BJ-BJM
      BJM=BJ
      BJ=BJP
   11 CONTINUE
      BESSJ=BJ
      ELSE
      M=2*((N+INT(SQRT(FLOAT(IACC*N))))/2)
      BESSJ=0.
      JSUM=0
      SUM=0.
      BJP=0.
      BJ=1.
      DO 12 J=M,1,-1
      BJM=J*TOX*BJ-BJP
      BJP=BJ
      BJ=BJM
      IF(ABS(BJ).GT.BIGNO)THEN
      BJ=BJ*BIGNI
      BJP=BJP*BIGNI
      BESSJ=BESSJ*BIGNI
      SUM=SUM*BIGNI
      ENDIF
      IF(JSUM.NE.0)SUM=SUM+BJ
      JSUM=1-JSUM
      IF(J.EQ.N)BESSJ=BJP
   12 CONTINUE
      SUM=2.*SUM-BJ
      BESSJ=BESSJ/SUM
      ENDIF
      IF(X.LT.0..AND.MOD(N,2).EQ.1) BESSJ=-BESSJ
      RETURN
      END
C
      REAL FUNCTION BESSJ0*8(X)
      IMPLICIT REAL*8 (A-H,O-Z)
      REAL*8 Y,P1,P2,P3,P4,P5,Q1,Q2,Q3,Q4,Q5,R1,R2,R3,R4,R5,R6,
     *    S1,S2,S3,S4,S5,S6
      DATA P1,P2,P3,P4,P5/1.D0,-.1098628627D-2,.2734510407D-4,
     *    -.2073370639D-5,.2093887211D-6/, Q1,Q2,Q3,Q4,Q5/-.1562499995D-
     *1,
     *    .1430488765D-3,-.6911147651D-5,.7621095161D-6,-.934945152D-7/
      DATA R1,R2,R3,R4,R5,R6/57568490574.D0,-13362590354.D0,651619640.7D
     *0,
     *    -11214424.18D0,77392.33017D0,-184.9052456D0/,
     *    S1,S2,S3,S4,S5,S6/57568490411.D0,1029532985.D0,
     *    9494680.718D0,59272.64853D0,267.8532712D0,1.D0/
      IF(DABS(X).LT.8.)THEN
        Y=X**2
        BESSJ0=(R1+Y*(R2+Y*(R3+Y*(R4+Y*(R5+Y*R6)))))
     *      /(S1+Y*(S2+Y*(S3+Y*(S4+Y*(S5+Y*S6)))))
      ELSE
        AX=DABS(X)
        Z=8.D0/AX
        Y=Z**2
        XX=AX-.785398164D0
        BESSJ0=DSQRT(.636619772D0/AX)*(DCOS(XX)*(P1+Y*(P2+Y*(P3+Y*(P4+Y
     *      *P5))))-Z*DSIN(XX)*(Q1+Y*(Q2+Y*(Q3+Y*(Q4+Y*Q5)))))
      ENDIF
      RETURN
      END
C
      REAL FUNCTION BESSJ1*8(X)
      IMPLICIT REAL*8 (A-H,O-Z)
      REAL*8 Y,P1,P2,P3,P4,P5,Q1,Q2,Q3,Q4,Q5,R1,R2,R3,R4,R5,R6,
     *    S1,S2,S3,S4,S5,S6
      DATA R1,R2,R3,R4,R5,R6/72362614232.D0,-7895059235.D0,242396853.1D0
     *,
     *    -2972611.439D0,15704.48260D0,-30.16036606D0/,
     *    S1,S2,S3,S4,S5,S6/144725228442.D0,2300535178.D0,
     *    18583304.74D0,99447.43394D0,376.9991397D0,1.D0/
      DATA P1,P2,P3,P4,P5/1.D0,.183105D-2,-.3516396496D-4,.2457520174D-5
     *,
     *    -.240337019D-6/, Q1,Q2,Q3,Q4,Q5/.04687499995D0,-.2002690873D-3
     *,
     *    .8449199096D-5,-.88228987D-6,.105787412D-6/
      IF(DABS(X).LT.8.)THEN
        Y=X**2
        BESSJ1=X*(R1+Y*(R2+Y*(R3+Y*(R4+Y*(R5+Y*R6)))))
     *      /(S1+Y*(S2+Y*(S3+Y*(S4+Y*(S5+Y*S6)))))
      ELSE
        AX=DABS(X)
        Z=8.D0/AX
        Y=Z**2
        XX=AX-2.356194491D0
        BESSJ1=DSQRT(.636619772D0/AX)*(DCOS(XX)*(P1+Y*(P2+Y*(P3+Y*(P4+Y
     *      *P5))))-Z*DSIN(XX)*(Q1+Y*(Q2+Y*(Q3+Y*(Q4+Y*Q5)))))
     *      *DSIGN(1.D0,X)
      ENDIF
      RETURN
      END
C
      SUBROUTINE WBSJA(Z,A,NMAX,ND,CB)
C--------------------------------------------------------------------
C BESSEL FUNCTION OF FRATCTIONAL ORDER AND COMPLEX ARGUMENT
C--------------------------------------------------------------------
      COMPLEX*16 Z,CB(0:*)
      COMPLEX*16 ZA,F,C,R,S,CBA(0:100),RR(0:100)
      DOUBLE PRECISION A,X,Y,YA
      DOUBLE PRECISION AL,XN,EPS,A2,A2N
      DOUBLE PRECISION ZERO,ONE,TWO
      REAL R0,D,T,Q,U,V,TC(11)
 
      DATA ZERO /0.0D0/, ONE /1.0D0/, TWO /2.0D0/
 
      DATA TC / 5.7941 E-5,-1.76148E-3, 2.08645E-2,-1.29013E-1,
     1          8.5777 E-1, 1.0125 E+0, 7.75   E-1, 2.3026 E+0,
     2          1.3863 E+0, 7.3576 E-1, 1.3591 E+0/
 
      X=DREAL(Z)
      Y=DIMAG(Z)
      IF(.NOT.(ZERO .LE. A .AND. A .LT. ONE) .OR.
     1  X .LE. ZERO .AND. Y .EQ. ZERO .OR. NMAX .GT. 100) THEN
       WRITE(6,100)
       RETURN
      END IF
      R0=ABS(Z)
      YA=ABS(Y)
      ZA=DCMPLX(X,YA)
      EPS=0.5*10.0**(-ND)
      DO 5 N = 0,NMAX
      RR(N)=ZERO
    5 CBA(N)=ZERO
      F=EXP(DCMPLX(YA,A*ATAN2(YA,X)-X))*(R0/TWO)**A/GAMMA(ONE+A)
      D=TC(8)*ND+TC(9)
      Q=0.
      IF(NMAX .GT. 0) THEN
       V=0.5*D/NMAX
       IF(V .LE. 10.) THEN
        T=TC(1)
        DO 6 I = 2,6
    6   T=V*T+TC(I)
       ELSE
        U=LOG(V)-TC(7)
        T=V/(U*(1.0+(TC(7)-LOG(U))/(1.0+U)))
       END IF
       Q=NMAX*T
      END IF
      T=1.0
      IF(YA .LT. D) THEN
       V=TC(10)*(D-YA)/R0
       IF(V .LE. 10.) THEN
        T=TC(1)
        DO 7 I = 2,6
    7   T=V*T+TC(I)
       ELSE
        U=LOG(V)-TC(7)
        T=V/(U*(1.0+(TC(7)-LOG(U))/(1.0+U)))
       END IF
      END IF
      NU=1.0+MAX(Q,TC(11)*R0*T)
 
      A2=TWO*A
      MU=-1
    2 MU=MU+1
      AL=ONE
      C=ONE
      DO 3 N = 1,NU
      XN=N
      AL=AL*(XN+A2)/(XN+ONE)
    3 C=DCMPLX(DIMAG(C),-DREAL(C))
      R=ZERO
      S=ZERO
      DO 4 N = NU,1,-1
      XN=N
      A2N=TWO*(A+XN)
      R=ZA/(A2N-ZA*R)
      IF(N .LE. NMAX) RR(N-1)=R
      AL=AL*(XN+ONE)/(XN+A2)
      S=R*(A2N*AL*C+S)
    4 C=DCMPLX(-DIMAG(C),DREAL(C))
      CB(0)=F/(ONE+S)
      DO 10 N = 0,NMAX-1
   10 CB(N+1)=RR(N)*CB(N)
      IF(Y .LT. ZERO) THEN
       DO 11 N = 0,NMAX
   11  CB(N)=CONJG(CB(N))
      END IF
      DO 12 N = 0,NMAX
      IF(ABS(CB(N)-CBA(N)) .GT. EPS*ABS(CB(N))) THEN
       DO 13 M = 0,NMAX
   13  CBA(M)=CB(M)
       NU=NU+5
       IF(MU .LE. 50) GO TO 2
       WRITE(6,101)
       RETURN
      END IF
   12 CONTINUE
      RETURN
  100 FORMAT(1X,'*****CERN C344 WBSJA ... UNREASONABLE ARGUMENT OR ',
     1          'ORDER')
  101 FORMAT(' *****CERN C344 WBSJA ... ITERATION DOES NOT CONVERGE,',
     1          ' TRY SMALLER ND')
      END
C
      SUBROUTINE TOPLO2(ZTXT,NDATE,NTIME,NUS,ENGY,SGMZ,BETAC,REVFRQ,
     1 ALPHA,CHROM,FREQ,RS,QV,SPRD,LBIN,MU,TT,QXYMM)
C-----------------------------------------------------------------------
C PLOT REAL PART OF EIGENVALUES ON FT09 FOR TOP DRAWER
C-----------------------------------------------------------------------
      IMPLICIT REAL*8(A-H,O-Z)
      LOGICAL*1 LBIN
      REAL*4      QXYMM(4)
      REAL*8 NUS
      CHARACTER*8 ZTXT(9)
      CHARACTER*8 NDATE,NTIME
C FOR VAX USERS
C     REAL*8 NDATE,NTIME
      WRITE(9,1002) (ZTXT(J),J=1,3),(ZTXT(L),L=4,9)
 1002 FORMAT(1X,' NEW FRAME'/
     11X,' SET FONT DUPLEX'/
     21X,' SET SIZE 13 BY 10'/
     31X,' SET WINDOW X FROM 2 9.7 Y FROM 1 TO 8'/
     41X,' SET TICKS SIZE 0.05'/
     51X,' TITLE 6.2 9.0 CENTER SIZE 2.0  ',
     1            1H','- Real Part of (N-N2x1)/N2s1 -',1H'/
     61X,' CASE ',1H','                G GV V  GV V  ',1H'/
     51X,' TITLE 2.0 8.6 SIZE 1.5  ',1H','MOSES -- ',3A8,1H'/
     51X,' MORE ',1H',6A8,1H'/
     61X,' TITLE BOTTOM ',1H','I2b1 (mA)',1H'/
     61X,' CASE         ',1H',' V V     ',1H'/
     71X,' TITLE LEFT   ',1H','Real (N-N2x1)/N2s1',1H'/
     71X,' CASE         ',1H','      G GV V  GV V',1H')
      WRITE(9,1003) QXYMM(1),QXYMM(2),QXYMM(3),QXYMM(4)
 1003 FORMAT(1X,' SET LIMIT X',2G13.5,' Y',2G13.5)
      WRITE(9,1010) NDATE,NTIME,TT,SPRD,NUS,ENGY,SGMZ,BETAC,REVFRQ,
     1ALPHA,CHROM,FREQ,RS,QV,LBIN,MU
 1010 FORMAT(1X,' TITLE 2.00 8.3 SIZE 1.2 ',1H',A8,5X,A8,
     15X,'VERSION 4.0',1H'/
     1' MORE ',1H',5X,'CPU TIME USED:',G10.3,' (s)',1H'/
     11X,' TITLE 10. 7.9 SIZE 1.2 ',1H','SPRD  =',G10.3,1H'/
     11X,' TITLE 10. 7.6 SIZE 1.2 ',1H','NUS   =',G10.3,1H'/
     11X,' TITLE 10. 7.3 SIZE 1.2 ',1H','ENGY  =',G10.3,' (GeV)',1H'/
     11X,' TITLE 10. 7.0 SIZE 1.2 ',1H','SGMZ  =',G10.3,' (cm)',1H'/
     11X,' TITLE 10. 6.7 SIZE 1.2 ',1H','BETAC =',G10.3,' (m)',1H'/
     11X,' TITLE 10. 6.4 SIZE 1.2 ',1H','REVFRQ=',G10.3,' (MHz)',1H'/
     11X,' TITLE 10. 6.1 SIZE 1.2 ',1H','ALPHA =',G10.3,1H'/
     11X,' TITLE 10. 5.8 SIZE 1.2 ',1H','CHORM =',G10.3,1H'/
     11X,' TITLE 10. 5.5 SIZE 1.2 ',1H','FREQ  =',G10.3,' (MHz)',1H'/
     11X,' TITLE 10. 5.2 SIZE 1.2 ',1H','RS    =',G10.3,' (MOhm/m)',1H'/
     11X,' TITLE 10. 4.9 SIZE 1.2 ',1H','QV    =',G10.3,1H'/
     11X,' TITLE 10. 4.6 SIZE 1.2 ',1H','LBIN  =',L3,1H'/
     11X,' TITLE 10. 4.3 SIZE 1.2 ',1H','MU    =',I3,1H')
      RETURN
      END
C
      SUBROUTINE TOPLO3(ZTXT,NDATE,NTIME,NUS,ENGY,SGMZ,BETAC,REVFRQ,
     1 ALPHA,CHROM,FREQ,RS,QV,SPRD,LBIN,MU,TT,QXYMM)
C-----------------------------------------------------------------------
C PLOT IMAGINARY PART OF EIGENVALUES ON FT09 FOR TOP DRAWER
C-----------------------------------------------------------------------
      IMPLICIT REAL*8(A-H,O-Z)
      LOGICAL*1 LBIN
      REAL*4      QXYMM(4)
      REAL*8 NUS
      CHARACTER*8 ZTXT(9)
      CHARACTER*8 NDATE,NTIME
C FOR VAX USERS
C     REAL*8 NDATE,NTIME
      WRITE(9,1002) (ZTXT(J),J=1,3),(ZTXT(L),L=4,9)
 1002 FORMAT(1X,' NEW FRAME'/
     11X,' SET FONT DUPLEX'/
     21X,' SET SIZE 13 BY 10'/
     31X,' SET WINDOW X FROM 2 9.7 Y FROM 1 TO 8'/
     41X,' SET TICKS SIZE 0.05'/
     51X,' TITLE 6.2 9.0 CENTER SIZE 2.0  ',
     1            1H','- Imaginary Part of (N-N2x1)/N2s1 -',1H'/
     61X,' CASE ',1H','                     G GV V  GV V  ',1H'/
     51X,' TITLE 2.0 8.6 SIZE 1.5  ',1H','MOSES -- ',3A8,1H'/
     51X,' MORE ',1H',6A8,1H'/
     61X,' TITLE BOTTOM ',1H','I2b1 (mA)',1H'/
     61X,' CASE         ',1H',' V V     ',1H'/
     71X,' TITLE LEFT   ',1H','Imag (N-N2x1)/N2s1',1H'/
     71X,' CASE         ',1H','      G GV V  GV V',1H')
      WRITE(9,1003) QXYMM(1),QXYMM(2),QXYMM(3),QXYMM(4)
 1003 FORMAT(1X,' SET LIMIT X',2G13.5,' Y',2G13.5)
      WRITE(9,1010) NDATE,NTIME,TT,SPRD,NUS,ENGY,SGMZ,BETAC,REVFRQ,
     1ALPHA,CHROM,FREQ,RS,QV,LBIN,MU
 1010 FORMAT(1X,' TITLE 2.00 8.3 SIZE 1.2 ',1H',A8,5X,A8,
     15X,'VERSION 4.0',1H'/
     1' MORE ',1H',5X,'CPU TIME USED:',G10.3,' (s)',1H'/
     11X,' TITLE 10. 7.9 SIZE 1.2 ',1H','SPRD  =',G10.3,1H'/
     11X,' TITLE 10. 7.6 SIZE 1.2 ',1H','NUS   =',G10.3,1H'/
     11X,' TITLE 10. 7.3 SIZE 1.2 ',1H','ENGY  =',G10.3,' (GeV)',1H'/
     11X,' TITLE 10. 7.0 SIZE 1.2 ',1H','SGMZ  =',G10.3,' (cm)',1H'/
     11X,' TITLE 10. 6.7 SIZE 1.2 ',1H','BETAC =',G10.3,' (m)',1H'/
     11X,' TITLE 10. 6.4 SIZE 1.2 ',1H','REVFRQ=',G10.3,' (MHz)',1H'/
     11X,' TITLE 10. 6.1 SIZE 1.2 ',1H','ALPHA =',G10.3,1H'/
     11X,' TITLE 10. 5.8 SIZE 1.2 ',1H','CHORM =',G10.3,1H'/
     11X,' TITLE 10. 5.5 SIZE 1.2 ',1H','FREQ  =',G10.3,' (MHz)',1H'/
     11X,' TITLE 10. 5.2 SIZE 1.2 ',1H','RS    =',G10.3,' (MOhm/m)',1H'/
     11X,' TITLE 10. 4.9 SIZE 1.2 ',1H','QV    =',G10.3,1H'/
     11X,' TITLE 10. 4.6 SIZE 1.2 ',1H','LBIN  =',L3,1H'/
     11X,' TITLE 10. 4.3 SIZE 1.2 ',1H','MU    =',I3,1H')
      RETURN
      END
C
      SUBROUTINE DRPLOT (NWRITE,X,Y,N,KSYMB,KEQUAL,XYMM,KSTORE)
C-----------------------------------------------------------------------
C  PRINT-PLOT SIGULATION FOR ONE OR SEVERAL CURVES ON THE LINEPRINTER
C  ORIGINAL VERSION: H.BRANDIS, TH-DARMSTADT
C-----------------------------------------------------------------------
      REAL Y(N)
      DIMENSION X(1),XYMM(4),INFO(690),           IPOT(10),
     1          TV(10),XB(10),IZEICH(7)
      CHARACTER*1 LZM,LZP,LZI,LZB,IZIF(10),KSYMB,KPRI(121),LZEA
      CHARACTER*4 KFMT(7)
      CHARACTER *3 IFT(7)
C LSP LZE DEFINE SIZE OF PRINT IN COLUMNS/LINES
      DATA TV / 0.2,0.5,0.5,1.,1.,1.,1.,2.,2.,2.  /
      DATA LZM,LZP,LZI,LZB, KBL,IZL / '-','+','I',' ' ,  0,0  /
      DATA KFMT / '(1H0', ',6X,', '10(1', 'PE9.', '2,  ', ' ', '))' /
      DATA IFT / '21X', '15X', '11X', '8X', '6X', '4X', '3X'  /
      DATA IZIF / '0', '1', '2', '3', '4', '5', '6', '7', '8', '9' /
      DATA LSP, LZE, LST, NDIM / 121, 42,  9, 690 /
C
      LZEI=ICHAR(KSYMB)
      IF (LZEI.LT.10.AND.LZEI.GE.0) LZEI=ICHAR(IZIF(LZEI+1))
      IF (KBL) 470,10,160
   10 KBL=1
      SPZE=FLOAT(LSP+LZE)
      LRX=LSP-1
      LRY=LZE-1
      IPOT(1)=1
      DO 20 I=2,LST
        IPOT(I)=IPOT(I-1)*8
   20 CONTINUE
      DO 30 I=1,NDIM
        INFO(I)=0
   30 CONTINUE
      DF=XYMM(2)-XYMM(1)
      IF (DF-5.E-4*ABS(XYMM(2)+XYMM(1))) 40,40,60
   40 IF (KEQUAL.EQ.0) GO TO 460
      XYMM(1)=X(1)
      XYMM(2)=X(1)
      DO 50 I=1,N
        XYMM(1)=AMIN1(XYMM(1),X(I))
        XYMM(2)=AMAX1(XYMM(2),X(I))
   50 CONTINUE
      DF=XYMM(2)-XYMM(1)
      IF (DF-5.E-4*ABS(XYMM(2)+XYMM(1))) 460,460,60
   60 P=10.**(INT(ALOG10(DF)+199.999)-200)
      IST=DF/P
   70 XT=TV(IST)*P
      NTP=INT(XYMM(2)/XT+AMAX1(SIGN(0.99,XYMM(2)),0.01))
      NTM=INT(XYMM(1)/XT+AMIN1(SIGN(0.99,XYMM(1)),0.01))
      NTX=NTP-NTM
      IF (NTX-8) 90,90,80
   80 IST=IST+1
      GO TO 70
   90 ITX=LRX/NTX
      NT0=-NTM+1
      XMIN=XT*FLOAT(NTM)
      DX=XT/FLOAT(ITX)
      KPX=ITX*NTX+1
      KFMT(6)=IFT(NTX-3)
      DF=XYMM(4)-XYMM(3)
      IF (DF-5.E-4*ABS(XYMM(4)+XYMM(3))) 100,100,120
  100 XYMM(3)=Y(1)
      XYMM(4)=Y(1)
      DO 110 I=1,N
        XYMM(3)=AMIN1(XYMM(3),Y(I))
        XYMM(4)=AMAX1(XYMM(4),Y(I))
  110 CONTINUE
      DF=XYMM(4)-XYMM(3)
      IF (DF-5.E-4*ABS(XYMM(4)+XYMM(3))) 460,460,120
  120 P=10.**(INT(ALOG10(DF)+199.999)-200)
      IST=DF/P
  130 YT=TV(IST)*P
      NTP=INT(XYMM(4)/YT+AMAX1(SIGN(0.99,XYMM(4)),0.01))
      NTM=INT(XYMM(3)/YT+AMIN1(SIGN(0.99,XYMM(3)),0.01))
      NTY=NTP-NTM
      IF (NTY-8) 150,150,140
  140 IST=IST+1
      GO TO 130
  150 ITY=LRY/NTY
      NZE0=ITY*NTP+1
      YMAX=YT*FLOAT(NTP)
      DY=YT/FLOAT(ITY)
      KPY=ITY*NTY+1
      GO TO 190
  160 IF (ICHAR(KSYMB)+1) 170,200,170
  170 DO 180 KZL=1,KBL
        IF (LZEI.EQ.IZEICH(KZL))GO TO 200
  180 CONTINUE
      KBL=MOD(KBL,7)+1
  190 KZL=KBL
      LZEA = CHAR(LZEI)
      IF (LZEA.EQ.LZB)LZEI=ICHAR(IZIF(KBL+1))
      IZEICH(KZL)=LZEI
  200 IF (KEQUAL) 220,210,220
  210 DXX=(XYMM(2)-XYMM(1))/DX/AMAX0(N-1,1)
      XX=(XYMM(1)-XMIN)/DX+1.5-DXX
  220 IF (N) 310,310,230
  230 DO 300 I=1,N
        IF (KEQUAL) 250,240,250
  240   SP=DXX*FLOAT(I)+XX
        GO TO 260
  250   SP=(X(I)-XMIN)/DX+1.5
  260   ZE=(YMAX-Y(I))/DY+1.5
        IF (ABS(SP)+ABS(ZE)-SPZE) 270,300,300
  270   NSP=INT(SP)-1
        NZE=INT(ZE)-1
        IF (NSP*(LRX-NSP)) 300,280,280
  280   IF (NZE*(LRY-NZE)) 300,290,290
  290   NPKT=NZE*LSP+NSP
        NAD=NPKT/LST
        NEX=MOD(NPKT,LST)
        INFO(NAD+1)=INFO(NAD+1)+IPOT(NEX+1)*(KZL-MOD(INFO(NAD+1)/
     +  IPOT(NEX+1),8))
  300 CONTINUE
  310 IF (KSTORE) 480,320,480
  320 DO 440 IZE=1,KPY
        KR=MOD(IZE-1,ITY)
        IF (KR) 360,330,360
  330   DO 340 ISP=1,KPX
          KPRI(ISP)=LZM
  340   CONTINUE
        DO 350 ISP=1,KPX,ITX
          KPRI(ISP)=LZP
  350   CONTINUE
        GO TO 390
  360   DO 370 ISP=1,KPX
          KPRI(ISP)=LZB
  370   CONTINUE
        DO 380 ISP=1,KPX,ITX
          KPRI(ISP)=LZI
  380   CONTINUE
  390   NPA=(IZE-1)*LSP-1
        DO 410 ISP=1,KPX
          IPK=ISP+NPA
          NAD=IPK/LST
          NEX=MOD(IPK,LST)
          IZL=MOD(INFO(NAD+1)/IPOT(NEX+1),8)
          IF (IZL) 410,410,400
  400     KPRI(ISP)=CHAR(IZEICH(IZL))
  410   CONTINUE
        IF (KR) 430,420,430
  420   YB=DY*FLOAT(NZE0-IZE)
        WRITE (NWRITE,490) YB,(KPRI(ISP),ISP=1,KPX)
        GO TO 440
  430   WRITE (NWRITE,500) (KPRI(ISP),ISP=1,KPX)
  440 CONTINUE
      DO 450 IT=1,NTX
        XB(IT)=XT*FLOAT(IT-NT0)
  450 CONTINUE
      WRITE (NWRITE,KFMT) (XB(IT),IT=1,NTX)
      KBL=0
      GO TO 480
  460 WRITE (NWRITE,510) XYMM
  470 KBL=-IABS(KSTORE)
  480 RETURN
C
  490 FORMAT (1PE10.2, 1X, 121A1)
  500 FORMAT (11X, 121A1)
  510 FORMAT(///1X,11H**WARNING**//1X,
     1'WRONG RANGE IN X OR Y GIVEN TO SUBROUTINE DRPLOT:'/
     2' XMIN=',1PE12.5/
     3' XMAX=',1PE12.5/
     4' YMIN=',1PE12.5/
     5' YMAX=',1PE12.5//)
      END
C
*VAXFOR EISCG2                                                                  
      SUBROUTINE EISCG2(NM,N,AR,AI,WR,WI,IERR)                                  
C     ALL EIGENVALUES OF A COMPLEX GENERAL MATRIX                               
C                                                                               
      DIMENSION AR(NM,NM),AI(NM,NM),WR(N),WI(N)                                 
      CALL CBAL(NM,N,AR,AI,LOW,IGH,WR)                                          
      CALL COMHES(NM,N,LOW,IGH,AR,AI,WR)                                        
      CALL COMLR(NM,N,LOW,IGH,AR,AI,WR,WI,IERR)                                 
      RETURN                                                                    
      END                                                                       
*VAXFOR CBAL                                                                    
      SUBROUTINE CBAL(NM,N,AR,AI,LOW,IGH,SCALE)                                 
      INTEGER I,J,K,L,M,N,JJ,NM,IGH,LOW,IEXC                                    
      REAL AR(NM,N),AI(NM,N),SCALE(N)                                           
      REAL C,F,G,R,S,B2,RADIX                                                   
      LOGICAL NOCONV                                                            
      RADIX = 2.                                                                
      B2 = RADIX * RADIX                                                        
      K = 1                                                                     
      L = N                                                                     
      GO TO 100                                                                 
   20 SCALE(M) = J                                                              
      IF (J .EQ. M) GO TO 50                                                    
      DO 30 I = 1, L                                                            
         F = AR(I,J)                                                            
         AR(I,J) = AR(I,M)                                                      
         AR(I,M) = F                                                            
         F = AI(I,J)                                                            
         AI(I,J) = AI(I,M)                                                      
         AI(I,M) = F                                                            
   30 CONTINUE                                                                  
      DO 40 I = K, N                                                            
         F = AR(J,I)                                                            
         AR(J,I) = AR(M,I)                                                      
         AR(M,I) = F                                                            
         F = AI(J,I)                                                            
         AI(J,I) = AI(M,I)                                                      
         AI(M,I) = F                                                            
   40 CONTINUE                                                                  
   50 GO TO (80,130), IEXC                                                      
   80 IF (L .EQ. 1) GO TO 280                                                   
      L = L - 1                                                                 
  100 DO 120 JJ = 1, L                                                          
         J = L + 1 - JJ                                                         
         DO 110 I = 1, L                                                        
            IF (I .EQ. J) GO TO 110                                             
            IF (AR(J,I) .NE. 0.0 .OR. AI(J,I) .NE. 0.0) GO TO 120               
  110    CONTINUE                                                               
         M = L                                                                  
         IEXC = 1                                                               
         GO TO 20                                                               
  120 CONTINUE                                                                  
      GO TO 140                                                                 
  130 K = K + 1                                                                 
  140 DO 170 J = K, L                                                           
         DO 150 I = K, L                                                        
            IF (I .EQ. J) GO TO 150                                             
            IF (AR(I,J) .NE. 0.0 .OR. AI(I,J) .NE. 0.0) GO TO 170               
  150    CONTINUE                                                               
         M = K                                                                  
         IEXC = 2                                                               
         GO TO 20                                                               
  170 CONTINUE                                                                  
      DO 180 I = K, L                                                           
  180 SCALE(I) = 1.0                                                            
  190 NOCONV = .FALSE.                                                          
      DO 270 I = K, L                                                           
         C = 0.0                                                                
         R = 0.0                                                                
         DO 200 J = K, L                                                        
            IF (J .EQ. I) GO TO 200                                             
            C = C + ABS(AR(J,I)) + ABS(AI(J,I))                                 
            R = R + ABS(AR(I,J)) + ABS(AI(I,J))                                 
  200    CONTINUE                                                               
         G = R / RADIX                                                          
         F = 1.0                                                                
         S = C + R                                                              
  210    IF (C .GE. G) GO TO 220                                                
         F = F * RADIX                                                          
         C = C * B2                                                             
         GO TO 210                                                              
  220    G = R * RADIX                                                          
  230    IF (C .LT. G) GO TO 240                                                
         F = F / RADIX                                                          
         C = C / B2                                                             
         GO TO 230                                                              
  240    IF ((C + R) / F .GE. 0.95 * S) GO TO 270                               
         G = 1.0 / F                                                            
         SCALE(I) = SCALE(I) * F                                                
         NOCONV = .TRUE.                                                        
         DO 250 J = K, N                                                        
            AR(I,J) = AR(I,J) * G                                               
            AI(I,J) = AI(I,J) * G                                               
  250    CONTINUE                                                               
         DO 260 J = 1, L                                                        
            AR(J,I) = AR(J,I) * F                                               
            AI(J,I) = AI(J,I) * F                                               
  260    CONTINUE                                                               
  270 CONTINUE                                                                  
      IF (NOCONV) GO TO 190                                                     
  280 LOW = K                                                                   
      IGH = L                                                                   
      RETURN                                                                    
      END                                                                       
*VAXFOR COMHES                                                                  
      SUBROUTINE COMHES(NM,N,LOW,IGH,AR,AI,INT)                                 
      INTEGER I,J,M,N,LA,NM,IGH,KP1,LOW,MM1,MP1                                 
      REAL AR(NM,N),AI(NM,N)                                                    
      REAL XR,XI,YR,YI                                                          
      INTEGER INT(IGH)                                                          
      COMPLEX X,Y                                                               
      REAL T1(2),T2(2)                                                          
      EQUIVALENCE (X,T1(1),XR),(T1(2),XI),(Y,T2(1),YR),(T2(2),YI)               
      LA = IGH - 1                                                              
      KP1 = LOW + 1                                                             
      IF (LA .LT. KP1) GO TO 200                                                
      DO 180 M = KP1, LA                                                        
         MM1 = M - 1                                                            
         XR = 0.0                                                               
         XI = 0.0                                                               
         I = M                                                                  
         DO 100 J = M, IGH                                                      
            IF (ABS(AR(J,MM1)) + ABS(AI(J,MM1))                                 
     X         .LE. ABS(XR) + ABS(XI)) GO TO 100                                
            XR = AR(J,MM1)                                                      
            XI = AI(J,MM1)                                                      
            I = J                                                               
  100    CONTINUE                                                               
         INT(M) = I                                                             
         IF (I .EQ. M) GO TO 130                                                
         DO 110 J = MM1, N                                                      
            YR = AR(I,J)                                                        
            AR(I,J) = AR(M,J)                                                   
            AR(M,J) = YR                                                        
            YI = AI(I,J)                                                        
            AI(I,J) = AI(M,J)                                                   
            AI(M,J) = YI                                                        
  110    CONTINUE                                                               
         DO 120 J = 1, IGH                                                      
            YR = AR(J,I)                                                        
            AR(J,I) = AR(J,M)                                                   
            AR(J,M) = YR                                                        
            YI = AI(J,I)                                                        
            AI(J,I) = AI(J,M)                                                   
            AI(J,M) = YI                                                        
  120    CONTINUE                                                               
  130    IF (XR .EQ. 0.0 .AND. XI .EQ. 0.0) GO TO 180                           
         MP1 = M + 1                                                            
         DO 160 I = MP1, IGH                                                    
            YR = AR(I,MM1)                                                      
            YI = AI(I,MM1)                                                      
            IF (YR .EQ. 0.0 .AND. YI .EQ. 0.0) GO TO 160                        
            Y = Y / X                                                           
            AR(I,MM1) = YR                                                      
            AI(I,MM1) = YI                                                      
            DO 140 J = M, N                                                     
               AR(I,J) = AR(I,J) - YR * AR(M,J) + YI * AI(M,J)                  
               AI(I,J) = AI(I,J) - YR * AI(M,J) - YI * AR(M,J)                  
  140       CONTINUE                                                            
            DO 150 J = 1, IGH                                                   
               AR(J,M) = AR(J,M) + YR * AR(J,I) - YI * AI(J,I)                  
               AI(J,M) = AI(J,M) + YR * AI(J,I) + YI * AR(J,I)                  
  150       CONTINUE                                                            
  160    CONTINUE                                                               
  180 CONTINUE                                                                  
  200 RETURN                                                                    
      END                                                                       
*VAXFOR COMLR                                                                   
      SUBROUTINE COMLR(NM,N,LOW,IGH,HR,HI,WR,WI,IERR)                           
      INTEGER I,J,L,M,N,EN,LL,MM,NM,IGH,IM1,ITS,LOW,MP1,ENM1,IERR               
      REAL HR(NM,N),HI(NM,N),WR(N),WI(N)                                        
      REAL SI,SR,TI,TR,XI,XR,YI,YR,ZZI,ZZR,MACHEP                               
      COMPLEX X,Y,Z                                                             
      REAL T1(2),T2(2),T3(2)                                                    
      EQUIVALENCE (X,T1(1),XR),(T1(2),XI),(Y,T2(1),YR),(T2(2),YI),              
     X            (Z,T3(1),ZZR),(T3(2),ZZI)                                     
      MACHEP=2.**(-23)                                                          
      IERR = 0                                                                  
C*UL  180 DO 200 I = 1, N                                                       
      DO 200 I = 1, N                                                           
         IF (I .GE. LOW .AND. I .LE. IGH) GO TO 200                             
         WR(I) = HR(I,I)                                                        
         WI(I) = HI(I,I)                                                        
  200 CONTINUE                                                                  
      EN = IGH                                                                  
      TR = 0.0                                                                  
      TI = 0.0                                                                  
  220 IF (EN .LT. LOW) GO TO 1001                                               
      ITS = 0                                                                   
      ENM1 = EN - 1                                                             
  240 DO 260 LL = LOW, EN                                                       
         L = EN + LOW - LL                                                      
         IF (L .EQ. LOW) GO TO 300                                              
         IF (ABS(HR(L,L-1)) + ABS(HI(L,L-1)) .LE.                               
     X      MACHEP * (ABS(HR(L-1,L-1)) + ABS(HI(L-1,L-1))                       
     X             + ABS(HR(L,L)) +ABS(HI(L,L)))) GO TO 300                     
  260 CONTINUE                                                                  
  300 IF (L .EQ. EN) GO TO 660                                                  
      IF (ITS .EQ. 30) GO TO 1000                                               
      IF (ITS .EQ. 10 .OR. ITS .EQ. 20) GO TO 320                               
      SR = HR(EN,EN)                                                            
      SI = HI(EN,EN)                                                            
      XR = HR(ENM1,EN) * HR(EN,ENM1) - HI(ENM1,EN) * HI(EN,ENM1)                
      XI = HR(ENM1,EN) * HI(EN,ENM1) + HI(ENM1,EN) * HR(EN,ENM1)                
      IF (XR .EQ. 0.0 .AND. XI .EQ. 0.0) GO TO 340                              
      YR = (HR(ENM1,ENM1) - SR) / 2.0                                           
      YI = (HI(ENM1,ENM1) - SI) / 2.0                                           
      Z = SQRT(CMPLX(YR**2-YI**2+XR,2.0*YR*YI+XI))                              
      IF (YR * ZZR + YI * ZZI .LT. 0.0) Z = -Z                                  
      X = X / (Y + Z)                                                           
      SR = SR - XR                                                              
      SI = SI - XI                                                              
      GO TO 340                                                                 
  320 SR = ABS(HR(EN,ENM1)) + ABS(HR(ENM1,EN-2))                                
      SI = ABS(HI(EN,ENM1)) + ABS(HI(ENM1,EN-2))                                
  340 DO 360 I = LOW, EN                                                        
         HR(I,I) = HR(I,I) - SR                                                 
         HI(I,I) = HI(I,I) - SI                                                 
  360 CONTINUE                                                                  
      TR = TR + SR                                                              
      TI = TI + SI                                                              
      ITS = ITS + 1                                                             
      XR = ABS(HR(ENM1,ENM1)) + ABS(HI(ENM1,ENM1))                              
      YR = ABS(HR(EN,ENM1)) + ABS(HI(EN,ENM1))                                  
      ZZR = ABS(HR(EN,EN)) + ABS(HI(EN,EN))                                     
      DO 380 MM = L, ENM1                                                       
         M = ENM1 + L - MM                                                      
         IF (M .EQ. L) GO TO 420                                                
         YI = YR                                                                
         YR = ABS(HR(M,M-1)) + ABS(HI(M,M-1))                                   
         XI = ZZR                                                               
         ZZR = XR                                                               
         XR = ABS(HR(M-1,M-1)) + ABS(HI(M-1,M-1))                               
         IF (YR .LE. MACHEP * ZZR / YI * (ZZR + XR + XI)) GO TO 420             
  380 CONTINUE                                                                  
  420 MP1 = M + 1                                                               
      DO 520 I = MP1, EN                                                        
         IM1 = I - 1                                                            
         XR = HR(IM1,IM1)                                                       
         XI = HI(IM1,IM1)                                                       
         YR = HR(I,IM1)                                                         
         YI = HI(I,IM1)                                                         
         IF (ABS(XR) + ABS(XI) .GE. ABS(YR) + ABS(YI)) GO TO 460                
         DO 440 J = IM1, N                                                      
            ZZR = HR(IM1,J)                                                     
            HR(IM1,J) = HR(I,J)                                                 
            HR(I,J) = ZZR                                                       
            ZZI = HI(IM1,J)                                                     
            HI(IM1,J) = HI(I,J)                                                 
            HI(I,J) = ZZI                                                       
  440    CONTINUE                                                               
         Z = X / Y                                                              
         WR(I) = 1.0                                                            
         GO TO 480                                                              
  460    Z = Y / X                                                              
         WR(I) = -1.0                                                           
  480    HR(I,IM1) = ZZR                                                        
         HI(I,IM1) = ZZI                                                        
         DO 500 J = I, EN                                                       
            HR(I,J) = HR(I,J) - ZZR * HR(IM1,J) + ZZI * HI(IM1,J)               
            HI(I,J) = HI(I,J) - ZZR * HI(IM1,J) - ZZI * HR(IM1,J)               
  500   CONTINUE                                                                
  520 CONTINUE                                                                  
      DO 640 J = MP1, EN                                                        
         XR = HR(J,J-1)                                                         
         XI = HI(J,J-1)                                                         
         HR(J,J-1) = 0.0                                                        
         HI(J,J-1) = 0.0                                                        
         IF (WR(J) .LE. 0.0) GO TO 580                                          
         DO 540 I = L, J                                                        
            ZZR = HR(I,J-1)                                                     
            HR(I,J-1) = HR(I,J)                                                 
            HR(I,J) = ZZR                                                       
            ZZI = HI(I,J-1)                                                     
            HI(I,J-1) = HI(I,J)                                                 
            HI(I,J) = ZZI                                                       
  540    CONTINUE                                                               
  580    DO 600 I = L, J                                                        
            HR(I,J-1) = HR(I,J-1) + XR * HR(I,J) - XI * HI(I,J)                 
            HI(I,J-1) = HI(I,J-1) + XR * HI(I,J) + XI * HR(I,J)                 
  600    CONTINUE                                                               
  640 CONTINUE                                                                  
      GO TO 240                                                                 
  660 WR(EN) = HR(EN,EN) + TR                                                   
      WI(EN) = HI(EN,EN) + TI                                                   
      EN = ENM1                                                                 
      GO TO 220                                                                 
 1000 IERR = EN                                                                 
 1001 RETURN                                                                    
      END                                                                       
*VAXFOR GAMMA   
      FUNCTION GAMMA(X)
      DOUBLE PRECISION DGAMMA,D
 
      SROUND(D)=D+(D-SNGL(D))
      GAMMA=SROUND(DGAMMA(DBLE(X)))
      RETURN
      END
*VAXFOR GAMMA64 
      FUNCTION DGAMMA(X)
C
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
C
      CHARACTER*(*) NAME
      PARAMETER(NAME='GAMMA/DGAMMA')
C
      CHARACTER*80 ERRTXT
 
      DIMENSION C(0:15)
 
      DATA C( 0) /3.65738 77250 83382 44D0/
      DATA C( 1) /1.95754 34566 61268 27D0/
      DATA C( 2) /0.33829 71138 26160 39D0/
      DATA C( 3) /0.04208 95127 65575 49D0/
      DATA C( 4) /0.00428 76504 82129 09D0/
      DATA C( 5) /0.00036 52121 69294 62D0/
      DATA C( 6) /0.00002 74006 42226 42D0/
      DATA C( 7) /0.00000 18124 02333 65D0/
      DATA C( 8) /0.00000 01096 57758 66D0/
      DATA C( 9) /0.00000 00059 87184 05D0/
      DATA C(10) /0.00000 00003 07690 81D0/
      DATA C(11) /0.00000 00000 14317 93D0/
      DATA C(12) /0.00000 00000 00651 09D0/
      DATA C(13) /0.00000 00000 00025 96D0/
      DATA C(14) /0.00000 00000 00001 11D0/
      DATA C(15) /0.00000 00000 00000 04D0/
 
      U=X
      IF(U .LE. 0) THEN
       WRITE(ERRTXT,101) U
C      CALL MTLPRT(NAME,'C302.1',ERRTXT)
       H=0
       GO TO 9
      ENDIF
    8 F=1
      IF(U .LT. 3) THEN
       DO 1 I = 1,INT(4-U)
       F=F/U
    1  U=U+1
      ELSE
       DO 2 I = 1,INT(U-3)
       U=U-1
    2  F=F*U
      END IF
      H=U+U-7
      ALFA=H+H
      B1=0
      B2=0
      DO 3 I = 15,0,-1
      B0=C(I)+ALFA*B1-B2
      B2=B1
    3 B1=B0
    9 DGAMMA=F*(B0-H*B2)
      RETURN
  101 FORMAT('ARGUMENT IS NEGATIVE = ',1P,E15.1)
      END
*VAXFOR ZEROX64 
      FUNCTION DZERO(A0,B0,EPS,MAXF,F,MODE)
C     Based on
C
C        J.C.P. Bus and T.J. Dekker, Two Efficient Algorithms with
C        Guaranteed Convergence for Finding a Zero of a Function,
C        ACM Trans. Math. Software 1 (1975) 330-345.
C
C        (MODE = 1: Algorithm M;    MODE = 2: Algorithm R)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      CHARACTER NAME*(*)
      CHARACTER*80 ERRTXT
      PARAMETER (NAME = 'DZERO')
      LOGICAL LMT
 
      DIMENSION IM1(2),IM2(2),LMT(2)
 
      PARAMETER (Z1 = 1, HALF = Z1/2)
 
      DATA IM1 /2,3/, IM2 /-1,3/
 
      IF(MODE .NE. 1 .AND. MODE .NE. 2) THEN
       C=0
       WRITE(ERRTXT,101) MODE
C      CALL MTLPRT(NAME,'C200.1',ERRTXT)
       GO TO 99
      ENDIF
      FA=F(B0)
      FB=F(A0)
      IF(FA*FB .GT. 0) THEN
       C=0
       WRITE(ERRTXT,102) A0,B0
C      CALL MTLPRT(NAME,'C200.2',ERRTXT)
       GO TO 99
      ENDIF
      ATL=ABS(EPS)
      B=A0
      A=B0
      LMT(2)=.TRUE.
      MF=2
    1 C=A
      FC=FA
    2 IE=0
    3 IF(ABS(FC) .LT. ABS(FB)) THEN
       IF(C .NE. A) THEN
        D=A
        FD=FA
       END IF
       A=B
       B=C
       C=A
       FA=FB
       FB=FC
       FC=FA
      END IF
      TOL=ATL*(1+ABS(C))
      H=HALF*(C+B)
      HB=H-B
      IF(ABS(HB) .GT. TOL) THEN
       IF(IE .GT. IM1(MODE)) THEN
        W=HB
       ELSE
        TOL=TOL*SIGN(Z1,HB)
        P=(B-A)*FB
        LMT(1)=IE .LE. 1
        IF(LMT(MODE)) THEN
         Q=FA-FB
         LMT(2)=.FALSE.
        ELSE
         FDB=(FD-FB)/(D-B)
         FDA=(FD-FA)/(D-A)
         P=FDA*P
         Q=FDB*FA-FDA*FB
        END IF
        IF(P .LT. 0) THEN
         P=-P
         Q=-Q
        END IF
        IF(IE .EQ. IM2(MODE)) P=P+P
        IF(P .EQ. 0 .OR. P .LE. Q*TOL) THEN
         W=TOL
        ELSEIF(P .LT. HB*Q) THEN
         W=P/Q
        ELSE
         W=HB
        END IF
       END IF
       D=A
       A=B
       FD=FA
       FA=FB
       B=B+W
       MF=MF+1
       IF(MF .GT. MAXF) THEN
C       CALL MTLPRT(NAME,'C200.3','TOO MANY FUNCTION CALLS')
        GO TO 99
       ENDIF
       FB=F(B)
       IF(FB .EQ. 0 .OR. SIGN(Z1,FC) .EQ. SIGN(Z1,FB)) GO TO 1
       IF(W .EQ. HB) GO TO 2
       IE=IE+1
       GO TO 3
      END IF
      DZERO=C
   99 CONTINUE
      RETURN
  101 FORMAT('MODE = ',I3,' ILLEGAL')
  102 FORMAT('F(A) AND F(B) HAVE THE SAME SIGN, A = ',1P,D15.8,
     1       ', B = ',D15.8)
      END
*VAXFOR REXPIN64
      FUNCTION DEXPIN(X)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      LOGICAL LEX
      CHARACTER NAME*(*),NAMEE*(*)
      PARAMETER (NAME = 'REXPIN/DEXPIN', NAMEE = 'REXPIE/DEXPIE')
      DIMENSION P1(5),Q1(5),P2(7),Q2(7),P3(7),Q3(7),P4(8),Q4(8)
      DIMENSION A1(8),B1(8),A2(8),B2(8),A3(8),B3(8)
 
      PARAMETER (Z1 = 1, R3 = -2*Z1/3, X0 = 0.37250 74107 81366 63D0)
      DATA P1
     1/+4.29312 52343 20972 6D+0, +3.98941 53870 32106 6D+1,
     2 +2.92525 18866 92054 9D+2, +4.25696 82638 59170 3D+2,
     3 -4.34981 43832 95212 0D+2/
      DATA Q1
     1/+1.00000 00000 00000 0D+0, +1.88992 88395 00296 9D+1,
     2 +1.50950 38744 25130 9D+2, +5.68052 52718 98695 5D+2,
     3 +7.53585 64359 84293 2D+2/
      DATA P2
     1/+4.30967 83946 93887 8D-1, +6.90522 52278 44435 7D+0,
     2 +2.30192 55939 13334 6D+1, +2.43784 08879 13167 3D+1,
     3 +9.04161 55694 63286 6D+0, +9.99979 57705 15949 7D-1,
     4 +4.65627 10797 50956 60D-7/
      DATA Q2
     1/+1.03400 13040 48739 8D-1, +3.31909 21359 33016 0D+0,
     2 +2.04494 78501 37941 7D+1, +4.12807 84189 14243 4D+1,
     3 +3.24264 21069 51380 5D+1, +1.00411 64382 90544 8D+1,
     4 +1.00000 00000 00000 0D+0/
      DATA P3
     1/-5.66575 20653 38687 4D+0, -5.45374 15888 31328 7D+2,
     2 -1.29885 68874 64841 0D+3, -8.95927 95777 29368 1D+2,
     3 -2.41055 82709 70148 5D+2, -2.66271 06043 18114 5D+1,
     4 -9.99999 99999 84469 1D-1/
      DATA Q3
     1/+6.31657 48328 08002 3D+2, +2.40401 71322 59089 5D+3,
     2 +2.77761 94950 91629 6D+3, +1.33278 53774 82572 3D+3,
     3 +2.92310 03938 85332 5D+2, +2.86271 06042 21919 0D+1,
     4 +1.00000 00000 00000 0D+0/
      DATA P4
     1/-8.66937 33995 10695 6D+0, -5.49142 26552 10851 5D+2,
     2 -4.21001 61535 70699 3D+3, -2.49301 39345 86475 9D+5,
     3 -1.19623 66934 92468 7D+5, -2.21744 62775 88453 8D+7,
     4 +3.89280 42131 12014 1D+6, -3.91546 07380 90955 5D+8/
      DATA Q4
     1/+3.41718 75000 00000 0D+1, -1.60708 92658 72208 5D+3,
     2 +3.57300 29805 85081 1D+4, -4.83547 43616 21635 1D+5,
     3 +4.28559 62461 17490 4D+6, -2.49033 37574 05403 3D+7,
     4 +8.91925 76757 56121 1D+7, -1.65254 29972 52109 1D+8/
      DATA A1
     1/-2.18086 38152 07237 1D+0, -2.19010 23385 48806 9D+1,
     2 +9.30816 38566 21651 5D+0, +2.50762 81129 35598 3D+1,
     3 -3.31842 53199 72211 2D+1, +6.01217 99083 00804 8D+1,
     4 -4.32531 13287 81345 8D+1, +1.00443 10922 80779 1D+0/
      DATA B1
     1/+0.00000 00000 00000 0D+0, +3.93707 70185 27150 0D+0,
     2 +3.00892 64837 29152 0D+2, -6.25041 16167 18755 4D+0,
     3 +1.00367 43951 67257 7D+3, +1.43256 73812 19376 0D+1,
     4 +2.73624 11988 93280 6D+3, +5.27468 85196 29078 5D-1/
      DATA A2
     1/-3.48334 65360 28526 1D+0, -1.86545 45488 33988 4D+1,
     2 -8.28561 99414 06413 2D+0, -3.23467 33030 54034 6D+1,
     3 +1.79601 68876 92516 4D+1, +1.75656 31546 96144 2D+0,
     4 -1.95022 32128 96598 2D+0, +9.99994 29607 47082 9D-1/
      DATA B2
     1/+0.00000 00000 00000 0D+0, +6.95000 65588 74339 8D+1,
     2 +5.72837 19383 73237 2D+1, +2.57776 38423 84398 7D+1,
     3 +7.60761 14800 77345 8D+2, +2.89516 72792 51350 5D+1,
     4 -3.43942 26689 98699 7D+0, +1.00083 86740 26391 2D+0/
      DATA A3
     1/-5.31686 62349 44816 2D+1, +8.91263 82257 37077 5D+0,
     2 -1.39381 36036 44050 7D+0, -3.08336 26905 17627 0D+1,
     3 -7.49289 16779 28844 3D+0, -5.00140 34551 59243 5D+0,
     4 -3.00000 01678 20851 8D+0, +1.00000 00000 00583 9D+0/
      DATA B3
     1/+0.00000 00000 00000 0D+0, +1.04745 36265 24683 0D+3,
     2 -6.74704 58046 58324 3D+0, +2.95999 39948 68313 3D+2,
     3 -4.31325 83614 66279 6D+0, -7.90404 99229 89255 1D+0,
     4 -2.99996 43294 44464 6D+0, +1.99999 99992 41308 9D+0/
 
       LEX=.FALSE.
       GO TO 9
 
       ENTRY DEXPIE
       LEX=.TRUE.
 
    9 IF(X .LE. -24) THEN
       AP=A3(1)-X
       DO 1 I = 2,7
    1  AP=A3(I)-X+B3(I)/AP
       H=(1-(A3(8)+B3(8)/AP)/X)/X
       IF(.NOT.LEX) H=EXP(-X)*H
      ELSE IF(X .LE. -12) THEN
       AP=A2(1)-X
       DO 2 I = 2,7
    2  AP=A2(I)-X+B2(I)/AP
       H=(A2(8)+B2(8)/AP)/X
       IF(.NOT.LEX) H=EXP(-X)*H
      ELSE IF(X .LE. -6) THEN
       AP=A1(1)-X
       DO 3 I = 2,7
    3  AP=A1(I)-X+B1(I)/AP
       H=(A1(8)+B1(8)/AP)/X
       IF(.NOT.LEX) H=EXP(-X)*H
      ELSE IF(X .LT. 0) THEN
       V=R3*X-2
       BP=0
       DP=P4(1)
       DO 4 I = 2,8
       AP=BP
       BP=DP
    4  DP=P4(I)-AP+V*BP
       BQ=0
       DQ=Q4(1)
       DO 14 I = 2,8
       AQ=BQ
       BQ=DQ
   14  DQ=Q4(I)-AQ+V*BQ
       H=-LOG(-X/X0)+(X+X0)*(DP-AP)/(DQ-AQ)
       IF(LEX) H=EXP(X)*H
      ELSE IF(X .EQ. 0) THEN
       H=0
C      IF(.NOT.LEX) CALL MTLPRT(NAME ,'C337.1','ARGUMENT X = 0')
C      IF(     LEX) CALL MTLPRT(NAMEE,'C337.1','ARGUMENT X = 0')
      ELSE IF(X .LT. 1) THEN
       AP=P1(1)
       AQ=Q1(1)
       DO 5 I = 2,5
       AP=P1(I)+X*AP
    5  AQ=Q1(I)+X*AQ
       H=-LOG(X)+AP/AQ
       IF(LEX) H=EXP(X)*H
      ELSE IF(X .LE. 4) THEN
       Y=1/X
       AP=P2(1)
       AQ=Q2(1)
       DO 6 I = 2,7
       AP=P2(I)+Y*AP
    6  AQ=Q2(I)+Y*AQ
       H=AP/AQ
       IF(.NOT.LEX) H=EXP(-X)*H
      ELSE
       Y=1/X
       AP=P3(1)
       AQ=Q3(1)
       DO 7 I = 2,7
       AP=P3(I)+Y*AP
    7  AQ=Q3(I)+Y*AQ
       H=Y*(1+Y*AP/AQ)
       IF(.NOT.LEX) H=EXP(-X)*H
      END IF
      DEXPIN=H
      RETURN
      END
C
      SUBROUTINE CPUTIM(TT,KTYPE)
C-----------------------------------------------------------------------
C RETURN THE CPU TIME SO FAR IN SECONDS
C USE TIMEST AND TIMEX IF THE CERN LIBRARY IS AVAIRABLE
C USE CTIME IF THE IMSL LIBRARY IS AVAIRABLE
C-----------------------------------------------------------------------
      REAL*8 TT
      COMMON /TPRM/ T2
      SAVE /TPRM/
      IF(KTYPE-2) 1,2,3
C-SET TIMER TO START THE CLOCK------------------------------------------
    1 CONTINUE
C     TIME0=CTIME()
      CALL TIMEST(TLIM)
      T2=0.
      RETURN
C-CPU TIME USED IN A RUN------------------------------------------------
    2 CONTINUE
C     T1=CTIME()
      CALL TIMEX(T1)
      TT=T1-T2
      T2=T1
      RETURN
C-TOTAL CPU TIME USED---------------------------------------------------
    3 CONTINUE
C     TT=CTIME()
      CALL TIMEX(TTT)
	TT=TTT
      RETURN
      END
C
      SUBROUTINE ASFILE(NME,NMEO,NMET)
C-----------------------------------------------------------------------
C RETURN FILE NAMES FOR OUTPUT FILES
C-----------------------------------------------------------------------
	CHARACTER*256 NMEO,NMET
	CHARACTER*1 NME(256),DOT,OCH,UCH,TCH,PCH
	DATA DOT/'.'/,OCH/'o'/,UCH/'u'/,TCH/'t'/,PCH/'p'/
C 	PRINT '(A256)', NMEA
	DO 1000 I=1,256
	IF(NME(I).NE.DOT) GO TO 1000
	N=I
 1000	CONTINUE
	WRITE(NMEO, 2000) (NME(I), I=1,N-1), DOT,OCH,UCH,TCH
	WRITE(NMET, 2000) (NME(I), I=1,N-1), DOT,TCH,OCH,PCH
 2000 FORMAT(256A1)
C	PRINT *, '*** THE ASSIGNED OUTPUT FILES ARE AS FOLLOWS: ***'
C     PRINT '(A12,A256)', 'OUTPUT FILE=',NMEO
C 	PRINT '(A12,A256)', 'TOPDRW FILE=',NMET
	PRINT *, '> MOSES IS NOW RUNNING. PLEASE WAIT...'
	RETURN
	END
C
      SUBROUTINE DATIME(NDATE,NTIME)
C-----------------------------------------------------------------------
C RETURN THE DATE AND TIME OF THE DAY
C-----------------------------------------------------------------------
C FOR IBM USERS
      CHARACTER*8 NDATE,NTIME
C FOR VAX USERS
C     REAL*8 NDATE,NTIME
      CALL DATIMH(NDATE,NTIME)
      RETURN
      END
C------------------------------------------------------------------------
C File name:
C      DATLIB fortran library for HP users
C Created:
C      Yong Ho Chin, LBL 1/3/94
C Description:
C      Just copy it to the end of the ABCI source code or link its
C      object module with that of ABCI. You must also link with libU77.
C
C      If IDATE, TIME and/or SECNDS are not available, edit this library
C      according to the instructions written before each routine.
C------------------------------------------------------------------------
      SUBROUTINE DATIMH (NDATE,NTIME)
C
      CHARACTER*8 NDATE,NTIME
C     DATA MONTH,IDAY,IYEAR/1,1,94/
      NTIME='00.00.00'
C IF IDATE IS NOT AVAILABLE, COMMENT OUT THE NEXT LINE
      CALL IDATE(MONTH,IDAY,IYEAR)
C IF TIME IS NOT AVAILABLE, COMMENT OUT THE NEXT LINE
      CALL TIME(NTIME)
      WRITE(NDATE,1000) IDAY,MONTH,IYEAR
 1000 FORMAT(I2,'/',I2,'/',I2)
      RETURN
      END
C
      SUBROUTINE TIMEST(TIMLIM)
C
      TIMLIM=TIMLIM
      RETURN
C
      ENTRY TIMEX (TRES)
C
      TRES=ETIME(x)
      RETURN
      END
C
      SUBROUTINE TIMEL(TRES)
C
      TRES=3600.
      RETURN
      END